// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef CHAIN_IMPL_H
#define CHAIN_IMPL_H

#include <time.h>

#include <Chain_skel.h>

class Link_impl : public POA_Link
{
    CORBA::ORB_var orb_; // The ORB
    const char* file_;  // File containing the IOR of the next link
    Link_var next_;     // Next link
    bool master_;       // Am I the master link in the chain
    long nextId_;       // Next message ID

#if defined(WIN32)
    clock_t startTime_; // Time of the start of the forward operation
#else
    double startTime_;
#endif
public:

    Link_impl(CORBA::ORB_ptr orb, const char* file);

    virtual void forward(const Link::Message& msg)
        throw(CORBA::SystemException);

    virtual void send(CORBA::Long nPings, CORBA::Long msgSize)
        throw(CORBA::SystemException);

    virtual void close_loop()
        throw(CORBA::SystemException);
};

#endif // CHAIN_IMPL_H
