// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/Util.h>

#include <Chain_impl.h>

#include <stdlib.h>
#include <errno.h>

#ifdef HAVE_FSTREAM
#   include <fstream>
#else
#   include <fstream.h>
#endif

#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

int
main(int argc, char* argv[], char*[])
{
    try
    {
	//
	// Create ORB and POA
	//
	CORBA::ORB_var orb = CORBA::ORB_init(argc, argv);
	CORBA::Object_var obj = orb -> resolve_initial_references("RootPOA");
	PortableServer::POA_var poa = PortableServer::POA::_narrow(obj);
	PortableServer::POAManager_var manager = poa -> the_POAManager();

	if(argc < 3)
	{
	    cerr << argv[0] << ": mine next" << endl;
	}
	const char* myRef = argv[1];
	const char* next = argv[2];

	//
	// Create implementation object
	//
	Link_impl impl(orb, next);
	Link_var r = impl._this();

	//
	// Save reference
	//
	CORBA::String_var s = orb -> object_to_string(r);
	
	ofstream out(myRef);
	if(out.fail())
	{
	    cerr << argv[0] << ": can't open `" << myRef << "': "
		 << strerror(errno) << endl;
	    return EXIT_FAILURE;
	}
	
	out << s << endl;
	out.close();
	
	//
	// Run implementation
	//
	manager -> activate();
	orb -> run();
    }
    catch(CORBA::SystemException& ex)
    {
	OB::PrintException(ex);
	return EXIT_FAILURE;
    }

    return EXIT_SUCCESS;
}
