// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef SERVER_IMPL_H
#define SERVER_IMPL_H

#include <Broadcaster_skel.h>

class Broadcaster_impl : public POA_Broadcaster
{
    CORBA::ORB_var orb_;

    Broadcaster::ReceiverDescSeq receiverDescSeq_;

    //
    // Add/remove receiver
    //
    void add(Receiver_ptr, const char*, const char*, const char*);
    void remove(Receiver_ptr);
    
public:

    Broadcaster_impl(CORBA::ORB_ptr orb);

    //
    // Functions from the .idl file
    //
    virtual void _cxx_register(Receiver_ptr, const char*, const char*,
			       const char*)
        throw(Broadcaster::AlreadyRegistered,
              Broadcaster::NickExists,
              CORBA::SystemException);

    virtual void registerWithCheck(Receiver_ptr, const char*, const char*,
				   const char*)
        throw(Broadcaster::ReceiverUnreachable,
              Broadcaster::AlreadyRegistered,
              Broadcaster::NickExists,
              CORBA::SystemException);

    virtual void unregister(Receiver_ptr)
        throw(Broadcaster::UnknownReceiver,
              CORBA::SystemException);

    virtual void setNickName(Receiver_ptr, const char*)
        throw(Broadcaster::UnknownReceiver,
              Broadcaster::NickExists,
              CORBA::SystemException);

    virtual void getReceiverByNick(const char*,
				   Broadcaster::ReceiverDescription_out)
        throw(Broadcaster::UnknownNick,
              CORBA::SystemException);

    virtual Broadcaster::StringSeq* getReceiverNames()
        throw(CORBA::SystemException);

    virtual void say(const char*)
        throw(CORBA::SystemException);
};

#endif
