// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef DefaultFactory_impl_h
#define DefaultFactory_impl_h

#include <Factory_skel.h>

//
// Forward declaration
//
class Database;

//
// This factory uses a default servant to implement the record objects
//
class DefaultFactory_impl : public POA_DBFactory
{
    CORBA::Long nextKey_; // Next available key
    Database* database_;
    CORBA::ORB_var orb_;
    PortableServer::POA_var poa_;

    DBRecord_ptr makeRef(CORBA::Long key);

public:
    DefaultFactory_impl(CORBA::ORB_ptr orb, PortableServer::POA_ptr parent);
    virtual ~DefaultFactory_impl();

    //
    // Factory operations
    //
    virtual DBRecord_ptr createRecord()
        throw(CORBA::SystemException);
    virtual void destroyByKey(CORBA::Long key)
        throw(DBFactory::NoRecord,
              CORBA::SystemException);
    virtual DBRecord_ptr getByKey(CORBA::Long key)
        throw(DBFactory::NoRecord,
              CORBA::SystemException);
    virtual DBFactory::DBRecordKeySeq* getAllKeys()
        throw(CORBA::SystemException);
};

#endif // DefaultFactory_impl_h
