// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef LocatorFactory_impl_h
#define LocatorFactory_impl_h

#include <Factory_skel.h>

//
// Forward declarations
//
class Database;
class Reaper;
class ReapTimer;
class Locator;

//
// The LocatorFactory_impl class
//
class LocatorFactory_impl : public POA_DBFactory
{
    CORBA::Long nextKey_; // Next available key
    Database* database_;
    CORBA::ORB_var orb_;
    PortableServer::POA_var poa_;
    Reaper* reaper_;
    ReapTimer* timer_;
    Locator* locator_;

    PortableServer::ObjectId* makeKey(CORBA::Long key);
    DBRecord_ptr makeRef(CORBA::Long key);

public:
    LocatorFactory_impl(CORBA::ORB_ptr orb, PortableServer::POA_ptr parent);
    virtual ~LocatorFactory_impl();

    //
    // Factory operations
    //
    virtual DBRecord_ptr createRecord()
        throw(CORBA::SystemException);
    virtual void destroyByKey(CORBA::Long key)
        throw(DBFactory::NoRecord,
              CORBA::SystemException);
    virtual DBRecord_ptr getByKey(CORBA::Long key)
        throw(DBFactory::NoRecord,
              CORBA::SystemException);
    virtual DBFactory::DBRecordKeySeq* getAllKeys()
        throw(CORBA::SystemException);
};

#endif // LocatorFactory_impl_h
