// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/Timer.h>

#include <ReapTimer.h>
#include <Reaper.h>

ReapTimer::ReapTimer(Reaper* reaper, int interval)
    : reaper_(reaper)
{
    interval_.tv_sec = interval;
    interval_.tv_usec = 0;
    activate(interval_, true);
}

void
ReapTimer::notify()
{
    //
    // Reactivate the timer and invoke the reaper
    //
    activate(interval_, true);
    reaper_ -> reap();
}
