// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/OCI_IIOP.h>

#include <Hello_impl.h>
#include <stdio.h>

#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

Hello_impl::Hello_impl(OCI::Current_ptr current)
    : current_(OCI::Current::_duplicate(current))
{
}

void
Hello_impl::hello()
    throw(CORBA::SystemException)
{
    cout << "Hello_impl::hello()" << endl;

    OCI::TransportInfo_var info = current_ -> get_oci_transport_info();
    OCI::IIOP::TransportInfo_var iiopInfo =
	OCI::IIOP::TransportInfo::_narrow(info);

    if(!CORBA::is_nil(iiopInfo))
    {
        OCI::IIOP::InetAddr_var remoteAddr = iiopInfo -> remote_addr();
        CORBA::UShort remotePort = iiopInfo -> remote_port();
        
	cout << "Call from: "
	     << (int)remoteAddr[0] << '.' << (int)remoteAddr[1] << '.'
	     << (int)remoteAddr[2] << '.' << (int)remoteAddr[3]
	     << ":" << remotePort << endl;
    }
}
