// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************


#include <OB/CORBA.h>
#include <OB/Util.h>

#include <Simple_impl.h>

#include <stdlib.h>
#include <errno.h>

#ifdef HAVE_FSTREAM
#   include <fstream>
#else
#   include <fstream.h>
#endif

#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

using namespace CORBA;

int
main(int argc, char* argv[], char*[])
{
    try
    {
	Object_var obj;

	//
	// Create ORB
	//
	ORB_var orb = ORB_init(argc, argv);

	//
	// Resolve the Root POA
	//
	obj = orb -> resolve_initial_references("RootPOA");
	PortableServer::POA_var root = PortableServer::POA::_narrow(obj);
	PortableServer::POAManager_var poaManager = root -> the_POAManager();

	//
	// Create implementation object
	//
	I_impl impl;
	I_var p = impl._this();

	//
	// Save reference
	//
	String_var s = orb -> object_to_string(p);

	const char* refFile = "I.ref";
	ofstream out(refFile);
	if(out.fail())
	{
	    cerr << argv[0] << ": can't open `" << refFile << "': "
		 << strerror(errno) << endl;
	    return 1;
	}

	out << s << endl;
	out.close();

	//
	// Run implementation
	//
	poaManager -> activate();
	orb -> run();
    }
    catch(SystemException& ex)
    {
	OB::PrintException(ex);
	return 1;
    }

    return 0;
}
