// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/Basic.h>
#include <OB/Except.h>
#include <OB/Template.h>
#include <OB/TemplateI.h>
#include <OB/OBTypes.h>
#include <OB/Declarations.h>
#include <OB/Environment.h>

using namespace CORBA;
using namespace OB;

// ----------------------------------------------------------------------
// External, non-inline duplicate/release for templates
// ----------------------------------------------------------------------

void
OBDuplicate(CORBA::Environment_ptr p)
{
    if(p)
	p -> _OB_incRef();
}

void
OBRelease(CORBA::Environment_ptr p)
{
    if(p)
	p -> _OB_decRef();
}

// ----------------------------------------------------------------------
// Template instantiations
// ----------------------------------------------------------------------

#ifndef HAVE_NO_EXPLICIT_TEMPLATES
template class OB::ObjVar< Environment >;
template class OB::ObjOut< Environment >;
//template class OB::ObjForSeq< Environment >;
//template class OB::ObjSeq< Environment >;
//template class OB::SeqVar< OB::ObjSeq< Environment > >;
//template class OB::SeqOut< OB::ObjSeq< Environment > >;
#else
#ifdef HAVE_PRAGMA_DEFINE
#pragma define(OB::ObjVar< Environment >)
#pragma define(OB::ObjOut< Environment >)
//#pragma define(OB::ObjForSeq< Environment >)
//#pragma define(OB::ObjSeq< Environment >)
//#pragma define(OB::SeqVar< OB::ObjSeq< Environment > >)
//#pragma define(OB::SeqOut< OB::ObjSeq< Environment > >)
#endif
#endif

// ----------------------------------------------------------------------
// Environment constructor and destructor
// ----------------------------------------------------------------------

Environment::Environment()
    : exception_(0)
{
}

Environment::~Environment()
{
    delete exception_;
}

// ----------------------------------------------------------------------
// Environment public member implementation
// ----------------------------------------------------------------------

void
Environment::exception(Exception* p)
{
    delete exception_;
    exception_ = p;
}

Exception*
Environment::exception() const
{
    return exception_;
}
