// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_GIOP_SERVER_H
#define OB_GIOP_SERVER_H

namespace OB
{

class GIOPServerStarter;
typedef GIOPServerStarter* GIOPServerStarter_ptr;

class Upcall;

} // End of namespace OB

void OBDuplicate(OB::GIOPServerStarter_ptr);
void OBRelease(OB::GIOPServerStarter_ptr);

namespace OB
{

//
// Declare GIOPServerStarter as a class
//
typedef ObjVar< GIOPServerStarter > GIOPServerStarter_var;

class Upcall;

//
// The GIOPServer class
//
class GIOPServer : public Server
{
    //
    // Hide copy-constructor and assignment operator
    //
    GIOPServer(const GIOPServer&);
    void operator=(const GIOPServer&);

protected:

    OCI::Acceptor_var acceptor_; // The acceptor
    GIOPServerStarter_var starter_; // The server starter
    bool enabled_; // Is this server enabled?
    Upcall* upcall_; // The upcall point for requests
    
public:
    
    GIOPServer(OCI::Acceptor_ptr, Upcall*);
    virtual ~GIOPServer();

    //
    // Destroy the server
    //
    virtual void destroy();

    //
    // Get the OCI acceptor
    //
    virtual OCI::Acceptor_ptr acceptor();

    //
    // Run the server
    //
    virtual bool run();

    //
    // Disable the server
    //
    virtual void disable();
};

} // End of namespace OB

#endif
