// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/Basic.h>
#include <OB/Template.h>
#include <OB/OBTypes.h>
#include <OB/Hashers.h>

using namespace CORBA;

ULong
OBHash(const char* key)
{
    ULong h = 0;
    ULong offset = 0;
    Long len = (Long)strlen(key);

    if(len < 16)
    {
        for(Long i = len ; i > 0 ; i--)
            h = (h * 37) + key[offset++];
    }
    else
    {
        Long skip = len / 8;
        for(Long i = len ; i > 0 ; i -= skip, offset += skip)
            h = (h * 39) + key[offset];
    }

    return h;
}

bool
OBHashCompare(const char* k1, const char* k2)
{
    return strcmp(k1, k2) == 0;
}

ULong
OBHash(const OB::OctetSeq& key)
{
    ULong h = 0;
    ULong offset = 0;
    Long len = (Long)key.length();

    if(len < 16)
    {
        for(Long i = len ; i > 0 ; i--)
            h = (h * 37) + (int)key[offset++];
    }
    else
    {
        ULong skip = len / 8;
        for(Long i = len ; i > 0 ; i -= skip, offset += skip)
            h = (h * 39) + (int)key[offset];
    }

    return h;
}

bool
OBHashCompare(const OB::OctetSeq& k1, const OB::OctetSeq& k2)
{
    return ((k1.length() == k2.length()) &&
            (memcmp(k1.get_buffer(), k2.get_buffer(), k1.length()) == 0));
}
