# **********************************************************************
#
# Copyright (c) 1998
# Object-Oriented Concepts, Inc.
# Billerica, MA, USA
#
# Copyright (c) 1998
# Object-Oriented Concepts GmbH
# Ettlingen, Germany
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

NAME		= $(top_srcdir)\lib\ob.lib

TARGETS		= $(NAME)

!include $(top_srcdir)\config\Make.rules.mak

IDLDIR		= $(top_srcdir)\idl\OB
INC_IDLDIR	= $(top_srcdir)\idl
HDIR		= $(top_srcdir)\include\OB
TDIR		= ..\translator

OBJS		= Basic.obj \
		  Except.obj \
		  Fixed.obj \
		  OBTypes.obj \
		  Any.obj \
		  TCKind.obj \
		  Dynamic.obj \
		  TypeCode.obj \
		  Environment.obj \
		  Context.obj \
		  NamedValue.obj \
		  Principal.obj \
		  IOP.obj \
		  Object.obj \
		  Policy.obj \
		  PolicyManager.obj \
		  PolicyValidator.obj \
		  ORBPolicyManager_impl.obj \
		  OBPolicies.obj \
		  OBPolicies_impl.obj \
		  OBV.obj \
		  Custom.obj \
		  Custom_impl.obj \
		  StringValue.obj \
		  IFR1.obj \
		  IFR2.obj \
		  IFR3.obj \
		  IFR4.obj \
		  ValueBase.obj \
		  ValueFactoryBase.obj \
		  AbstractBase.obj \
		  ServiceInfo.obj \
		  ORB.obj \
		  OARoot.obj \
		  POA.obj \
		  POAInterface.obj \
		  POACommon.obj \
		  POA_impl.obj \
		  POAAdapterActivator.obj \
		  POAAdapterActivator_skel.obj \
		  POAServantManager.obj \
		  POAServantManager_skel.obj \
		  POACurrent.obj \
		  POACurrent_impl.obj \
		  POAManager.obj \
		  POAManager_impl.obj \
		  POAPolicies.obj \
                  POAPolicies_impl.obj \
		  POAServantActivator.obj \
		  POAServantActivator_skel.obj \
		  POAServantLocator.obj \
		  POAServantLocator_skel.obj \
		  CollocatedClient.obj \
		  Hashers.obj \
		  POAServantBase.obj \
		  DII.obj \
		  DSI.obj \
		  Current.obj \
		  DynAny.obj \
		  DynAny_impl.obj \
		  Timer.obj \
		  SelectReactor.obj \
		  GIOP.obj \
		  GIOPClient.obj \
		  GIOPClientWorker.obj \
		  GIOPServer.obj \
		  GIOPServerStarter.obj \
		  GIOPServerWorker.obj \
		  IIOP.obj \
		  Properties.obj \
		  IIOPInit.obj \
		  CONV_FRAME.obj \
		  CodeSetDatabase.obj \
		  CodeSetDatabaseInit.obj \
		  CharMapDatabaseInit.obj \
		  CodeSetUtil.obj \
		  CodeConverter.obj \
		  OCIBuffer.obj \
		  OCI.obj \
		  OCI_impl.obj \
		  OCI_IIOP.obj \
		  OCI_IIOP_impl.obj \
		  Net.obj \
		  Util.obj \
		  Stream.obj \
		  StubImplBase.obj \
		  License.obj \
		  Version.obj \
		  NTService.obj \
		  WinReactor.obj 

# Also in non-DLL mode needed for the clean target
DEF_NAME	= ob.def
DLL_NAME	= $(top_srcdir)\lib\ob.dll
EXP_NAME	= $(top_srcdir)\lib\ob.exp

!if "$(DLL)" == "yes"

ALL_CXXFLAGS	= $(CXXFLAGS)
ALL_CPPFLAGS	= /DOB_BUILD_DLL /I. $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_DLLLIBS	= $(OB_DLLLIBS) $(DLLLIBS)


$(NAME): $(DLL_NAME)

$(DLL_NAME): $(OBJS) $(DEF_NAME)
	$(LINK) $(LINKDLLFLAGS) /def:$(DEF_NAME) /out:$@ $(OBJS) $(ALL_DLLLIBS)

$(DEF_NAME): $(OBJS)
	perl $(top_srcdir)\..\config\makedef.pl $(DEF_NAME) OB $(OBJS)

!else

ALL_CXXFLAGS	= $(CXXFLAGS)
ALL_CPPFLAGS	= /I. $(OB_CPPFLAGS) $(CPPFLAGS)

$(NAME): $(OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(OBJS)

!endif

$(top_srcdir)\include\OB\WinConfig.h: $(top_srcdir)\..\config\WinConfig.h
	copy $(top_srcdir)\..\config\WinConfig.h $@

$(top_srcdir)\include\OB\Config.h: $(top_srcdir)\include\OB\WinConfig.h \
				   $(top_srcdir)\..\config\Make.rules.mak
	del /q $@
!if "$(WITH_JTC)" == "yes"
	echo #define HAVE_JTC 1 >> $@
!else
	echo /* #undef HAVE_JTC */ >> $@
!endif
!if "$(DLL)" == "yes"
	echo #define OB_DLL 1 >> $@
!else
	echo /* #undef OB_DLL */ >> $@
!endif
!if "$(OLD_IOSTREAM)" != "yes"
	echo #define HAVE_IOSTREAM 1 >> $@
!else
	echo /* #undef HAVE_IOSTREAM */ >> $@
!endif
	echo #include "WinConfig.h" >> $@

clean::
	del /q $(top_srcdir)\include\OB\Config.h


OBTypes.cpp $(HDIR)\OBTypes.h: $(IDLDIR)\OBTypes.idl
	if exist $(IDL) \
	    del /q OBTypes.cpp $(HDIR)\OBTypes.h & \
	    del /q OBTypes_skel.cpp $(HDIR)\OBTypes_skel.h & \
	    $(IDL) -I$(INC_IDLDIR) --no-type-codes --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\OBTypes.idl & \
	    move OBTypes.h $(HDIR) & \
	    move OBTypes_skel.h $(HDIR)

TCKind.cpp $(HDIR)\TCKind.h: $(IDLDIR)\TCKind.idl
	if exist $(IDL) \
	    del /q TCKind.cpp $(HDIR)\TCKind.h $(HDIR)\TCKind_skel.h & \
	    del /q TCKind_skel.cpp $(HDIR)\TCKind_skel.h & \
	    $(IDL) -I$(INC_IDLDIR) --no-type-codes --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\TCKind.idl & \
	    move TCKind.h $(HDIR) & \
	    move TCKind_skel.h $(HDIR)

OBV.cpp $(HDIR)\OBV.h: $(IDLDIR)\OBV.idl
	if exist $(IDL) \
	    del /q OBV.cpp $(HDIR)\OBV.h & \
	    del /q OBV_skel.cpp $(HDIR)\OBV_skel.h & \
	    $(IDL) -I$(INC_IDLDIR) --no-type-codes --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\OBV.idl & \
	    move OBV.h $(HDIR) & \
	    move OBV_skel.h $(HDIR)

Custom.cpp $(HDIR)\Custom.h: $(IDLDIR)\Custom.idl
	if exist $(IDL) \
	    del /q Custom.cpp $(HDIR)\Custom.h & \
	    $(IDL) -I$(INC_IDLDIR) --no-type-codes \
	    --no-skeletons --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\Custom.idl & \
	    move Custom.h $(HDIR)

StringValue.cpp $(HDIR)\StringValue.h: $(IDLDIR)\StringValue.idl
	if exist $(IDL) \
	    del /q StringValue.cpp $(HDIR)\StringValue.h & \
	    $(IDL) -I$(INC_IDLDIR) --this-header-dir OB \
	    --no-skeletons --dll-import OB_IMPORT $(IDLDIR)\StringValue.idl & \
	    move StringValue.h $(HDIR)

Dynamic.cpp $(HDIR)\Dynamic.h: $(IDLDIR)\Dynamic.idl
	if exist $(IDL) \
	    del /q Dynamic.cpp $(HDIR)\Dynamic.h & \
	    $(IDL) -I$(INC_IDLDIR) --no-type-codes --this-header-dir OB \
	    --no-skeletons --dll-import OB_IMPORT $(IDLDIR)\Dynamic.idl & \
	    move Dynamic.h $(HDIR)

IFR1.cpp $(HDIR)\IFR1.h: $(IDLDIR)\IFR1.idl
	if exist $(IDL) \
	    del /q IFR1.cpp $(HDIR)\IFR1.h & \
	    del /q IFR1_skel.cpp $(HDIR)\IFR1_skel.h & \
	    $(IDL) -I$(INC_IDLDIR) --ignore-undefined --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\IFR1.idl & \
	    move IFR1.h $(HDIR) & \
	    move IFR1_skel.h $(HDIR)

IFR2.cpp $(HDIR)\IFR2.h: $(IDLDIR)\IFR2.idl
	if exist $(IDL) \
	    del /q IFR2.cpp $(HDIR)\IFR2.h & \
	    del /q IFR2_skel.cpp $(HDIR)\IFR2_skel.h & \
	    $(IDL) -I$(INC_IDLDIR) --ignore-undefined --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\IFR2.idl & \
	    move IFR2.h $(HDIR) & \
	    move IFR2_skel.h $(HDIR)

IFR3.cpp $(HDIR)\IFR3.h: $(IDLDIR)\IFR3.idl
	if exist $(IDL) \
	    del /q IFR3.cpp $(HDIR)\IFR3.h & \
	    del /q IFR3_skel.cpp $(HDIR)\IFR3_skel.h & \
	    $(IDL) -I$(INC_IDLDIR) --ignore-undefined --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\IFR3.idl & \
	    move IFR3.h $(HDIR) & \
	    move IFR3_skel.h $(HDIR)

IFR4.cpp $(HDIR)\IFR4.h: $(IDLDIR)\IFR4.idl
	if exist $(IDL) \
	    del /q IFR4.cpp $(HDIR)\IFR4.h & \
	    del /q IFR4_skel.cpp $(HDIR)\IFR4_skel.h & \
	    $(IDL) -I$(INC_IDLDIR) --ignore-undefined --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\IFR4.idl & \
	    move IFR4.h $(HDIR) & \
	    move IFR4_skel.h $(HDIR)

$(HDIR)\IFR.h: $(IDLDIR)\IFR.idl
	if exist $(IDL) \
	    del /q IFR.cpp $(HDIR)\IFR.h & \
	    $(IDL) -I$(INC_IDLDIR) --ignore-undefined --this-header-dir OB \
	    --no-skeletons --dll-import OB_IMPORT $(IDLDIR)\IFR.idl & \
	    move IFR.h $(HDIR) & \
	    del /q IFR.cpp

IOP.cpp $(HDIR)\IOP.h: $(IDLDIR)\IOP.idl
	if exist $(IDL) \
	    del /q IOP.cpp $(HDIR)\IOP.h & \
	    del /q IOP_skel.cpp $(HDIR)\IOP_skel.h & \
	    $(IDL) -I$(INC_IDLDIR) --no-type-codes --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\IOP.idl & \
	    move IOP.h $(HDIR) & \
	    move IOP_skel.h $(HDIR)

GIOP.cpp $(HDIR)\GIOP.h: $(IDLDIR)\GIOP.idl
	if exist $(IDL) \
	    del /q GIOP.cpp $(HDIR)\GIOP.h & \
	    $(IDL) -I$(INC_IDLDIR) --no-skeletons --no-type-codes \
	    --this-header-dir OB --dll-import OB_IMPORT $(IDLDIR)\GIOP.idl & \
	    move GIOP.h $(HDIR)

IIOP.cpp $(HDIR)\IIOP.h: $(IDLDIR)\IIOP.idl
	if exist $(IDL) \
	    del /q IIOP.cpp $(HDIR)\IIOP.h & \
	    $(IDL) -I$(INC_IDLDIR) --no-skeletons --no-type-codes
	    --this-header-dir OB --dll-import OB_IMPORT $(IDLDIR)\IIOP.idl & \
	    move IIOP.h $(HDIR)

CONV_FRAME.cpp $(HDIR)\CONV_FRAME.h: $(IDLDIR)\CONV_FRAME.idl
	if exist $(IDL) \
	    del /q CONV_FRAME.cpp $(HDIR)\CONV_FRAME.h & \
	    $(IDL) -I$(INC_IDLDIR) --no-skeletons --no-type-codes \
	    --this-header-dir OB --dll-import OB_IMPORT \
	    $(IDLDIR)\CONV_FRAME.idl & \
	    move CONV_FRAME.h $(HDIR)

DynAny.cpp $(HDIR)\DynAny.h: $(IDLDIR)\DynAny.idl
	if exist $(IDL) \
	    del /q DynAny.cpp $(HDIR)\DynAny.h & \
	    $(IDL) -I$(INC_IDLDIR)  --locality-constrained \
	    --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\DynAny.idl & \
	    move DynAny.h $(HDIR) & \

Current.cpp $(HDIR)\Current.h: $(IDLDIR)\Current.idl
	if exist $(IDL) \
	    del /q Current.cpp $(HDIR)\Current.h & \
	    $(IDL) -I$(INC_IDLDIR)  --locality-constrained \
	    --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\Current.idl & \
	    move Current.h $(HDIR) & \

Policy.cpp $(HDIR)\Policy.h: $(IDLDIR)\Policy.idl
	if exist $(IDL) \
	    del /q Policy.cpp $(HDIR)\Policy.h & \
	    $(IDL) -I$(INC_IDLDIR)  --locality-constrained \
	    --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\Policy.idl & \
	    move Policy.h $(HDIR)

PolicyManager.cpp $(HDIR)\PolicyManager.h: $(IDLDIR)\PolicyManager.idl
	if exist $(IDL) \
	    del /q PolicyManager.cpp $(HDIR)\PolicyManager.h & \
	    $(IDL) -I$(INC_IDLDIR) --locality-constrained \
	    --no-virtual-inheritance --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\PolicyManager.idl & \
	    move PolicyManager.h $(HDIR)

OBPolicies.cpp $(HDIR)\OBPolicies.h: $(IDLDIR)\OBPolicies.idl
	if exist $(IDL) \
	    del /q OBPolicies.cpp $(HDIR)\OBPolicies.h & \
	    $(IDL) -I$(INC_IDLDIR)  --locality-constrained \
	    --no-virtual-inheritance --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\OBPolicies.idl & \
	    move OBPolicies.h $(HDIR)

POACommon.cpp $(HDIR)\POACommon.h: $(IDLDIR)\POACommon.idl
	if exist $(IDL) \
	    del /q POACommon.cpp $(HDIR)\POACommon.h & \
	    del /q POACommon_skel.cpp & \
	    del /q $(HDIR)\POACommon_skel.h & \
	    $(IDL) -I$(INC_IDLDIR) --ignore-undefined --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\POACommon.idl & \
	    move POACommon.h $(HDIR) & \
	    move POACommon_skel.h $(HDIR)

POA.cpp $(HDIR)\POA.h: $(IDLDIR)\POA.idl
	if exist $(IDL) \
	    del /q POA.cpp $(HDIR)\POA.h & \
	    del /q POA_skel.cpp $(HDIR)\POA_skel.h & \
	    $(IDL) -I$(INC_IDLDIR) --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\POA.idl & \
	    move POA.h $(HDIR) & \
	    move POA_skel.h $(HDIR)

POAInterface.cpp $(HDIR)\POAInterface.h: $(IDLDIR)\POAInterface.idl
	if exist $(IDL) \
	    del /q POAInterface.cpp $(HDIR)\POAInterface.h & \
	    $(IDL) -I$(INC_IDLDIR) --locality-constrained \
	    --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\POAInterface.idl & \
	    move POAInterface.h $(HDIR)

POAAdapterActivator.cpp $(HDIR)\POAAdapterActivator.h: \
	$(IDLDIR)\POAAdapterActivator.idl
	if exist $(IDL) \
	    del /q POAAdapterActivator.cpp $(HDIR)\POAAdapterActivator.h & \
	    del /q POAAdapterActivator_skel.cpp & \
	    del /q $(HDIR)\POAAdapterActivator_skel.h & \
	    $(IDL) -I$(INC_IDLDIR) --ignore-undefined --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\POAAdapterActivator.idl & \
	    move POAAdapterActivator.h $(HDIR) & \
	    move POAAdapterActivator_skel.h $(HDIR)

POAServantManager.cpp $(HDIR)\POAServantManager.h: \
	$(IDLDIR)\POAServantManager.idl
	if exist $(IDL) \
	    del /q POAServantManager.cpp $(HDIR)\POAServantManager.h & \
	    del /q POAServantManager_skel.cpp & \
	    del /q $(HDIR)\POAServantManager_skel.h & \
	    $(IDL) -I$(INC_IDLDIR) --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\POAServantManager.idl & \
	    move POAServantManager.h $(HDIR) & \
	    move POAServantManager_skel.h $(HDIR)

POACurrent.cpp $(HDIR)\POACurrent.h: $(IDLDIR)\POACurrent.idl
	if exist $(IDL) \
	    del /q POACurrent.cpp $(HDIR)\POACurrent.h & \
	    $(IDL) -I$(INC_IDLDIR)  --locality-constrained \
	    --this-header-dir OB --ignore-undefined \
	    --dll-import OB_IMPORT $(IDLDIR)\POACurrent.idl & \
	    move POACurrent.h $(HDIR)

POAPolicies.cpp $(HDIR)\POAPolicies.h: $(IDLDIR)\POAPolicies.idl
	if exist $(IDL) \
	    del /q POAPolicies.cpp $(HDIR)\POAPolicies.h & \
	    $(IDL) -I$(INC_IDLDIR)  --locality-constrained \
	    --dll-import OB_IMPORT $(IDLDIR)\POAPolicies.idl & \
	    move POAPolicies.h $(HDIR)

POAManager.cpp $(HDIR)\POAManager.h: $(IDLDIR)\POAManager.idl
	if exist $(IDL) \
	    del /q POAManager.cpp $(HDIR)\POAManager.h & \
	    $(IDL) -I$(INC_IDLDIR) --locality-constrained \
	    --no-virtual-inheritance --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\POAManager.idl & \
	    move POAManager.h $(HDIR)

POAServantActivator.cpp $(HDIR)\POAServantActivator.h: \
					$(IDLDIR)\POAServantActivator.idl
	if exist $(IDL) \
	    del /q POAServantActivator.cpp $(HDIR)\POAServantActivator.h & \
	    del /q POAServantActivator_skel.cpp & \
	    del /q $(HDIR)\POAServantActivator_skel.h & \
	    $(IDL) -I$(INC_IDLDIR) --ignore-undefined --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\POAServantActivator.idl & \
	    move POAServantActivator.h $(HDIR) & \
	    move POAServantActivator_skel.h $(HDIR)

POAServantLocator.cpp $(HDIR)\POAServantLocator.h: \
					$(IDLDIR)\POAServantLocator.idl
	if exist $(IDL) \
	    del /q POAServantLocator.cpp $(HDIR)\POAServantLocator.h & \
	    del /q POAServantLocator_skel.cpp & \
	    del /q $(HDIR)\POAServantLocator_skel.h & \
	    $(IDL) -I$(INC_IDLDIR) --ignore-undefined --this-header-dir OB \
	    --dll-import OB_IMPORT $(IDLDIR)\POAServantLocator.idl & \
	    move POAServantLocator.h $(HDIR) & \
	    move POAServantLocator_skel.h $(HDIR)

OCI.cpp $(HDIR)\OCI.h: $(IDLDIR)\OCI.idl
	if exist $(IDL) \
	    del /q OCI.cpp $(HDIR)\OCI.h & \
	    $(IDL) -I$(INC_IDLDIR) --locality-constrained \
	    --this-header-dir OB --no-virtual-inheritance \
	    --dll-import OB_IMPORT $(IDLDIR)\OCI.idl & \
	    move OCI.h $(HDIR) & \

OCI_IIOP.cpp $(HDIR)\OCI_IIOP.h: $(IDLDIR)\OCI_IIOP.idl
	if exist $(IDL) \
	    del /q OCI_IIOP.cpp $(HDIR)\OCI_IIOP.h & \
	    $(IDL) -I$(INC_IDLDIR)  --locality-constrained \
	    --this-header-dir OB --no-virtual-inheritance \
	    --dll-import OB_IMPORT $(IDLDIR)\OCI_IIOP.idl & \
	    move OCI_IIOP.h $(HDIR) & \

install:: all
	$(INSTALL_DATA) $(NAME) $(libdir)

!if "$(DLL)" == "yes"

install:: all
	$(INSTALL_DATA) $(DLL_NAME) $(bindir)
	$(INSTALL_DATA) $(EXP_NAME) $(libdir)

!endif

clean::
	@del /q $(DLL_NAME) $(EXP_NAME) $(DEF_NAME)

!include .windep
