// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_POLICIES_IMPL_H
#define OB_POLICIES_IMPL_H

namespace OB
{

class ProtocolPolicy_impl : public ProtocolPolicy
{
    //
    // Hide copy-constructor and assignment operator
    //
    ProtocolPolicy_impl(const ProtocolPolicy_impl&);
    void operator=(const ProtocolPolicy_impl&);

    IOP::ProfileId value_;

public:

    ProtocolPolicy_impl(IOP::ProfileId);
    ~ProtocolPolicy_impl();

    virtual IOP::ProfileId value()
        throw(CORBA::SystemException);

    virtual CORBA::PolicyType policy_type()
        throw(CORBA::SystemException);
    virtual CORBA::Policy_ptr copy()
        throw(CORBA::SystemException);
    virtual void destroy()
        throw(CORBA::SystemException);
};

class ConnectionReusePolicy_impl : public ConnectionReusePolicy
{
    //
    // Hide copy-constructor and assignment operator
    //
    ConnectionReusePolicy_impl(const ConnectionReusePolicy_impl&);
    void operator=(const ConnectionReusePolicy_impl&);

    CORBA::Boolean value_;

public:

    ConnectionReusePolicy_impl(CORBA::Boolean);
    ~ConnectionReusePolicy_impl();

    virtual CORBA::Boolean value()
        throw(CORBA::SystemException);

    virtual CORBA::PolicyType policy_type()
        throw(CORBA::SystemException);
    virtual CORBA::Policy_ptr copy()
        throw(CORBA::SystemException);
    virtual void destroy()
        throw(CORBA::SystemException);
};

class ReconnectPolicy_impl : public ReconnectPolicy
{
    //
    // Hide copy-constructor and assignment operator
    //
    ReconnectPolicy_impl(const ReconnectPolicy_impl&);
    void operator=(const ReconnectPolicy_impl&);

    CORBA::Boolean value_;

public:

    ReconnectPolicy_impl(CORBA::Boolean);
    ~ReconnectPolicy_impl();

    virtual CORBA::Boolean value()
        throw(CORBA::SystemException);

    virtual CORBA::PolicyType policy_type()
        throw(CORBA::SystemException);
    virtual CORBA::Policy_ptr copy()
        throw(CORBA::SystemException);
    virtual void destroy()
        throw(CORBA::SystemException);
};

class TimeoutPolicy_impl : public TimeoutPolicy
{
    //
    // Hide copy-constructor and assignment operator
    //
    TimeoutPolicy_impl(const TimeoutPolicy_impl&);
    void operator=(const TimeoutPolicy_impl&);

    CORBA::ULong value_;

public:

    TimeoutPolicy_impl(CORBA::ULong timeout);
    ~TimeoutPolicy_impl();

    virtual CORBA::ULong value()
        throw(CORBA::SystemException);

    virtual CORBA::PolicyType policy_type()
        throw(CORBA::SystemException);
    virtual CORBA::Policy_ptr copy()
        throw(CORBA::SystemException);
    virtual void destroy()
        throw(CORBA::SystemException);
};

} // End of namespace OB

#endif
