// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/Basic.h>
#include <OB/Except.h>
#include <OB/Template.h>
#include <OB/TemplateI.h>
#include <OB/OBTypes.h>
#include <OB/Declarations.h>
#include <OB/OCIBuffer.h>

// ----------------------------------------------------------------------
// External, non-inline duplicate/release for templates
// ----------------------------------------------------------------------

void
OBDuplicate(OCI::Buffer_ptr p)
{
    if(p)
	p -> _OB_incRef();
}

void
OBRelease(OCI::Buffer_ptr p)
{
    if(p)
	p -> _OB_decRef();
}

// ----------------------------------------------------------------------
// Template instantiations
// ----------------------------------------------------------------------

#ifndef HAVE_NO_EXPLICIT_TEMPLATES
template class OB::ObjVar< OCI::Buffer >;
template class OB::ObjForSeq< OCI::Buffer >;
template class OB::ObjSeq< OCI::Buffer, int >;
template class OB::SeqVar< OB::ObjSeq< OCI::Buffer, int > >;
#else
#ifdef HAVE_PRAGMA_DEFINE
#pragma define(OB::ObjVar< OCI::Buffer >)
#pragma define(OB::ObjForSeq< OCI::Buffer >)
#pragma define(OB::ObjSeq< OCI::Buffer, int >)
#pragma define(OB::SeqVar< OB::ObjSeq< OCI::Buffer, int > >)
#endif
#endif
