// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_ORBPOLICYMANAGER_IMPL_H
#define OB_ORBPOLICYMANAGER_IMPL_H

namespace CORBA
{

class ORBPolicyManager_impl : public PolicyManager
{
    //
    // Hide copy-constructor and assignment operator
    //
    ORBPolicyManager_impl(const ORBPolicyManager_impl&);
    void operator=(const ORBPolicyManager_impl&);

    PolicyList& policies_;

    ORBPolicyManager_impl(PolicyList&);
    friend class ORB; // ORBs may create ORBPolicyManagers

public:

    ~ORBPolicyManager_impl();

    virtual Policy_ptr get_policy_override(PolicyType)
        throw(SystemException);

    virtual PolicyList*
    get_specific_policy_overrides(const PolicyTypeSeq&)
        throw(SystemException);

    virtual PolicyList* get_all_policy_overrides()
        throw(SystemException);

    virtual void add_policy_overrides(const PolicyList&)
        throw(PolicyManager::InvalidPolicies,
              SystemException);

    virtual void remove_policy_overrides(const PolicyTypeSeq&)
        throw(SystemException);

    virtual void replace_all_policy_overrides(const PolicyList&)
        throw(PolicyManager::InvalidPolicies,
              SystemException);
};

} // End of namespace CORBA

#endif
