// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef POA_CURRENT_IMPL_H
#define POA_CURRENT_IMPL_H

namespace PortableServer
{

//
// Forward declaration
//
class POACurrentState;

//
// The PortableServer::Current_impl class
//
class Current_impl : public Current
{
#ifdef HAVE_JTC
    JTCThreadKey stateKey_;
#else
    POACurrentState* state_;
#endif

public:

    Current_impl();
    ~Current_impl();

    //
    // IDL:omg.org/PortableServer/Current/get_POA:1.0
    //
    virtual POA_ptr get_POA()
        throw(Current::NoContext,
              CORBA::SystemException);

    //
    // IDL:omg.org/PortableServer/Current/get_object_id:1.0
    //
    virtual ObjectId* get_object_id()
        throw(Current::NoContext,
              CORBA::SystemException);

    //
    // ORBacus internal methods.
    //
    void _OB_preinvoke(POA_ptr,
                       ServantBase*,
		       const char*,
                       const ObjectId&,
                       const OB::OctetSeq&,
                       ServantLocator::Cookie cookie);
    
    void _OB_postinvoke();

    bool _OB_inUpcall() const;
        
    ServantBase* _OB_getServant();
        
    const OB::OctetSeq& _OB_getKey();
        
    ServantLocator::Cookie _OB_getCookie();

    const ObjectId& _OB_getObjectId();

    const char* _OB_getOp();
};

} // End of namespace PortableServer

#endif
