// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_POAMANAGER_IMPL_H
#define OB_POAMANAGER_IMPL_H

namespace PortableServer
{

//
// Forward declarations
//
class POA_impl;

//
// The PortableServer::POAManager class
//
class POAManager_impl : public POAManager OB_COMMA_RECURSIVE_MUTEX
{
    typedef OB::FixSeq< POA_impl*, int > POASeq;
    POASeq poas_;
    bool terminating_;
    
    POAManager::State state_;

    void stateChange(POAManager::State);

#ifdef HAVE_JTC
    JTCMonitor stateChange_;
#endif
    
public:
    POAManager_impl();

    //
    // Standard IDL to C++ Mapping
    //
    virtual void activate()
        throw(POAManager::AdapterInactive,
              CORBA::SystemException);
    
    virtual void hold_requests(CORBA::Boolean)
        throw(POAManager::AdapterInactive,
              CORBA::SystemException);
    
    virtual void discard_requests(CORBA::Boolean)
        throw(POAManager::AdapterInactive,
              CORBA::SystemException);
    
    virtual void deactivate(CORBA::Boolean, CORBA::Boolean)
        throw(POAManager::AdapterInactive,
              CORBA::SystemException);
    
    virtual POAManager::State get_state()
        throw(CORBA::SystemException);

    //
    // ORBacus internal functions
    // Application programs must not use these functions directly
    //
        
    void _OB_add(POA_impl*);
    void _OB_remove(POA_impl*);
        
#ifdef HAVE_JTC
    void _OB_waitStateChange();
#endif
};

} // End of namespace PortableServer

#endif
