// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef PortableServer_POLICIES_IMPL_H
#define PortableServer_POLICIES_IMPL_H

namespace PortableServer
{

//
// The PortableServer::ThreadPolicy class
//
class ThreadPolicy_impl : virtual public ThreadPolicy
{
    //
    // Hide copy-constructor and assignment operator
    //
    ThreadPolicy_impl(const ThreadPolicy_impl&);
    void operator=(const ThreadPolicy_impl&);
    
    ThreadPolicyValue value_;
    
public:
    
    ThreadPolicy_impl(ThreadPolicyValue);
    ~ThreadPolicy_impl();

    //
    // Standard IDL to C++ Mapping
    //
    virtual ThreadPolicyValue value()
        throw(CORBA::SystemException);

    virtual CORBA::PolicyType policy_type()
        throw(CORBA::SystemException);
    virtual CORBA::Policy_ptr copy()
        throw(CORBA::SystemException);
    virtual void destroy()
        throw(CORBA::SystemException);
};

//
// The PortableServer::LifespanPolicy class
//
class LifespanPolicy_impl : virtual public LifespanPolicy
{
    //
    // Hide copy-constructor and assignment operator
    //
    LifespanPolicy_impl(const LifespanPolicy_impl&);
    void operator=(const LifespanPolicy_impl&);
    
    LifespanPolicyValue value_;
    
public:
    
    LifespanPolicy_impl(LifespanPolicyValue);
    ~LifespanPolicy_impl();

    //
    // Standard IDL to C++ Mapping
    //
    virtual LifespanPolicyValue value()
        throw(CORBA::SystemException);

    virtual CORBA::PolicyType policy_type()
        throw(CORBA::SystemException);
    virtual CORBA::Policy_ptr copy()
        throw(CORBA::SystemException);
    virtual void destroy()
        throw(CORBA::SystemException);
};

//
// The PortableServer::IdUniquenessPolicy class
//
class IdUniquenessPolicy_impl : virtual public IdUniquenessPolicy
{
    //
    // Hide copy-constructor and assignment operator
    //
    IdUniquenessPolicy_impl(const IdUniquenessPolicy_impl&);
    void operator=(const IdUniquenessPolicy_impl&);
    
    IdUniquenessPolicyValue value_;
    
public:
    
    IdUniquenessPolicy_impl(IdUniquenessPolicyValue);
    ~IdUniquenessPolicy_impl();

    //
    // Standard IDL to C++ Mapping
    //
    virtual IdUniquenessPolicyValue value()
        throw(CORBA::SystemException);

    virtual CORBA::PolicyType policy_type()
        throw(CORBA::SystemException);
    virtual CORBA::Policy_ptr copy()
        throw(CORBA::SystemException);
    virtual void destroy()
        throw(CORBA::SystemException);
};

//
// The PortableServer::IdAssignmentPolicy class
//
class IdAssignmentPolicy_impl : virtual public IdAssignmentPolicy
{
    //
    // Hide copy-constructor and assignment operator
    //
    IdAssignmentPolicy_impl(const IdAssignmentPolicy_impl&);
    void operator=(const IdAssignmentPolicy_impl&);
    
    IdAssignmentPolicyValue value_;
    
public:
    
    IdAssignmentPolicy_impl(IdAssignmentPolicyValue);
    ~IdAssignmentPolicy_impl();

    //
    // Standard IDL to C++ Mapping
    //
    virtual IdAssignmentPolicyValue value()
        throw(CORBA::SystemException);

    virtual CORBA::PolicyType policy_type()
        throw(CORBA::SystemException);
    virtual CORBA::Policy_ptr copy()
        throw(CORBA::SystemException);
    virtual void destroy()
        throw(CORBA::SystemException);
};

//
// The PortableServer::ImplicitActivationPolicy class
//
class ImplicitActivationPolicy_impl : virtual public ImplicitActivationPolicy
{
    //
    // Hide copy-constructor and assignment operator
    //
    ImplicitActivationPolicy_impl(const ImplicitActivationPolicy_impl&);
    void operator=(const ImplicitActivationPolicy_impl&);
    
    ImplicitActivationPolicyValue value_;
    
public:
    
    ImplicitActivationPolicy_impl(ImplicitActivationPolicyValue);
    ~ImplicitActivationPolicy_impl();

    //
    // Standard IDL to C++ Mapping
    //
    virtual ImplicitActivationPolicyValue value()
        throw(CORBA::SystemException);

    virtual CORBA::PolicyType policy_type()
        throw(CORBA::SystemException);
    virtual CORBA::Policy_ptr copy()
        throw(CORBA::SystemException);
    virtual void destroy()
        throw(CORBA::SystemException);
};

//
// The PortableServer::ServantRetentionPolicy class
//
class ServantRetentionPolicy_impl : virtual public ServantRetentionPolicy
{
    //
    // Hide copy-constructor and assignment operator
    //
    ServantRetentionPolicy_impl(const ServantRetentionPolicy_impl&);
    void operator=(const ServantRetentionPolicy_impl&);
    
    ServantRetentionPolicyValue value_;
    
public:
    
    ServantRetentionPolicy_impl(ServantRetentionPolicyValue);
    ~ServantRetentionPolicy_impl();

    //
    // Standard IDL to C++ Mapping
    //
    virtual ServantRetentionPolicyValue value()
        throw(CORBA::SystemException);

    virtual CORBA::PolicyType policy_type()
        throw(CORBA::SystemException);
    virtual CORBA::Policy_ptr copy()
        throw(CORBA::SystemException);
    virtual void destroy()
        throw(CORBA::SystemException);
};

//
// The PortableServer::RequestProcessingPolicy class
//
class RequestProcessingPolicy_impl : virtual public RequestProcessingPolicy
{
    //
    // Hide copy-constructor and assignment operator
    //
    RequestProcessingPolicy_impl(const RequestProcessingPolicy_impl&);
    void operator=(const RequestProcessingPolicy_impl&);
    
    RequestProcessingPolicyValue value_;
    
public:
    
    RequestProcessingPolicy_impl(RequestProcessingPolicyValue);
    ~RequestProcessingPolicy_impl();

    //
    // Standard IDL to C++ Mapping
    //
    virtual RequestProcessingPolicyValue value()
        throw(CORBA::SystemException);

    virtual CORBA::PolicyType policy_type()
        throw(CORBA::SystemException);
    virtual CORBA::Policy_ptr copy()
        throw(CORBA::SystemException);
    virtual void destroy()
        throw(CORBA::SystemException);
};

//
// ORBacus extensions
//

//
// The PortableServer::SynchronizationPolicy class
//
class SynchronizationPolicy_impl : virtual public SynchronizationPolicy
{
    //
    // Hide copy-constructor and assignment operator
    //
    SynchronizationPolicy_impl(const SynchronizationPolicy_impl&);
    void operator=(const SynchronizationPolicy_impl&);
    
    SynchronizationPolicyValue value_;
    
public:
    
    SynchronizationPolicy_impl(SynchronizationPolicyValue);
    ~SynchronizationPolicy_impl();

    //
    // Standard IDL to C++ Mapping
    //
    virtual SynchronizationPolicyValue value()
        throw(CORBA::SystemException);

    virtual CORBA::PolicyType policy_type()
        throw(CORBA::SystemException);
    virtual CORBA::Policy_ptr copy()
        throw(CORBA::SystemException);
    virtual void destroy()
        throw(CORBA::SystemException);
};

} // End of namespace PortableServer

#endif
