// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_UPCALL_H
#define OB_UPCALL_H

namespace OB
{

//
// Forward declarations
//
class Downcall;
typedef Downcall* Downcall_ptr;

//
// The Upcall class. This abstract class represents an interface that
// is used to up-call.
//
class Upcall
{
public:
    
    virtual ~Upcall() { }

    //
    // Invoke a method request.
    //
    virtual void invoke(Downcall_ptr,
                        CORBA::ULong,
                        const OctetSeq&,
                        const char*,
                        Buffer&,
                        bool,
                        CORBA::ULong,
                        CORBA::ULong,
                        OCI::TransportInfo_ptr) = 0;

    //
    // Determine if an object with the provided object key exists.
    //
    virtual bool findByKey(const OctetSeq&) = 0;
};

} // End of namespace OB

#endif
