// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/Basic.h>
#include <OB/Template.h>
#include <OB/TemplateI.h>
#include <OB/Except.h>
#include <OB/OBTypes.h>
#include <OB/Declarations.h>
#include <OB/Any.h>
#include <OB/OBV.h>
#include <OB/IOP.h>
#include <OB/StubImplBase.h>
#include <OB/Object.h>
#include <OB/Policy.h>
#include <OB/IFR2.h>
#include <OB/ORB.h>
#include <OB/OCI.h>
#include <OB/OBPolicies.h>
#include <OB/NativeTypes.h>
#include <OB/POAServantBase.h>
#include <OB/POA.h>
#include <OB/POAServantLocator.h>
#include <OB/Stream.h>
#include <OB/ValueFactoryBase.h>

using namespace CORBA;
using namespace OB;

// ----------------------------------------------------------------------
// Template instantiations
// ----------------------------------------------------------------------

#ifndef HAVE_NO_EXPLICIT_TEMPLATES
template class OB::ObjVar< ValueFactoryBase >;
#else
#ifdef HAVE_PRAGMA_DEFINE
#pragma define(OB::ObjVar< ValueFactoryBase >)
#endif
#endif

// ----------------------------------------------------------------------
// ValueFactoryBase constructor and destructor
// ----------------------------------------------------------------------

ValueFactoryBase::ValueFactoryBase()
{
}

ValueFactoryBase::~ValueFactoryBase()
{
}

// ----------------------------------------------------------------------
// ValueFactoryBase public member functions
// ----------------------------------------------------------------------

void
ValueFactoryBase::_add_ref()
{
    _OB_incRef();
}

void
ValueFactoryBase::_remove_ref()
{
    _OB_decRef();
}

ValueFactory
ValueFactoryBase::_downcast(ValueFactory f)
{
    return f;
}

void*
ValueFactoryBase::_OB_downcastHelp(const char* _ob_id) const
{
    if(strcmp("IDL:omg.org/CORBA/ValueFactoryBase:1.0", _ob_id) == 0)
        return (void*)this;
    else
        return 0;
}

const char*
ValueFactoryBase::_OB_typeId() const
{
    return "IDL:omg.org/CORBA/ValueFactoryBase:1.0";
}

ValueBase*
ValueFactoryBase::_OB_copyValue(ValueBase* vb, const char* id)
{
    ValueBase* result = 0;

    if(vb != 0)
    {
        //
        // XXX Can we optimize this using _copy_value()?
        //
        //result = vb -> _copy_value();

        CountStream count;
        count.count_Value(vb, id);
        Buffer buf(count.count());
        OutputStream out(buf, 0);
        out.write_Value(vb, id);
        InputStream in(buf, 0, false);
        result = in.read_Value(id);
    }

    return result;
}

void
OBRelease(CORBA::ValueFactoryBase* f)
{
    if(f != 0)
        f -> _remove_ref();
}

void
OBDuplicate(CORBA::ValueFactoryBase* f)
{
    if(f != 0)
        f -> _add_ref();
}
