typedef union
{
    //
    // General types
    //
    char* string;
    IdlStringSeq* stringSeq;

    CORBA::Long longVal;
    CORBA::ULong uLongVal;
    CORBA::Char charVal;
    CORBA::Double doubleVal;
    CORBA::Boolean booleanVal;

    CORBA::Any* any;
    IdlAnySeq* anySeq;

    //
    // Special types
    //
    IdlDeclarator* declarator;
    IdlDeclaratorSeq* declaratorSeq;
    IdlValueInfo* valueInfo;

    //
    // Types from the IR
    //
    CORBA::IDLType_ptr idlType;
    CORBA::StructDef_ptr structDef;
    CORBA::UnionDef_ptr unionDef;
    CORBA::ExceptionDef_ptr exceptionDef;
    CORBA::AttributeMode attributeMode;
    CORBA::StructMember* structMember;
    CORBA::StructMemberSeq* structMemberSeq;
    CORBA::UnionMemberSeq* unionMemberSeq;
    CORBA::UnionMember* unionMember;
    CORBA::InterfaceDef_ptr interfaceDef;
    CORBA::InterfaceDefSeq* interfaceDefSeq;
    CORBA::OperationMode operationMode;
    CORBA::ParameterMode parameterMode;
    CORBA::ParameterDescription* parameterDescription;
    CORBA::ParDescriptionSeq* parDescriptionSeq;
    CORBA::ExceptionDefSeq* exceptionDefSeq;
    CORBA::Visibility memberVisibility;
    CORBA::Initializer* initializer;
} YYSTYPE;
#define	IDL_ABSTRACT	258
#define	IDL_ANY	259
#define	IDL_ATTRIBUTE	260
#define	IDL_BOOLEAN	261
#define	IDL_CASE	262
#define	IDL_CHAR	263
#define	IDL_CONST	264
#define	IDL_CONTEXT	265
#define	IDL_CUSTOM	266
#define	IDL_DEFAULT	267
#define	IDL_DOUBLE	268
#define	IDL_ENUM	269
#define	IDL_EXCEPTION	270
#define	IDL_FIXED	271
#define	IDL_FLOAT	272
#define	IDL_IN	273
#define	IDL_INIT	274
#define	IDL_INOUT	275
#define	IDL_INTERFACE	276
#define	IDL_LONG	277
#define	IDL_MODULE	278
#define	IDL_NATIVE	279
#define	IDL_OBJECT	280
#define	IDL_OCTET	281
#define	IDL_ONEWAY	282
#define	IDL_OUT	283
#define	IDL_PRIVATE	284
#define	IDL_PUBLIC	285
#define	IDL_RAISES	286
#define	IDL_READONLY	287
#define	IDL_SEQUENCE	288
#define	IDL_SHORT	289
#define	IDL_STRING	290
#define	IDL_STRUCT	291
#define	IDL_SUPPORTS	292
#define	IDL_SWITCH	293
#define	IDL_TRUNCATABLE	294
#define	IDL_TYPEDEF	295
#define	IDL_UNSIGNED	296
#define	IDL_UNION	297
#define	IDL_VALUEBASE	298
#define	IDL_VALUETYPE	299
#define	IDL_VOID	300
#define	IDL_WCHAR	301
#define	IDL_WSTRING	302
#define	IDL_LEFT_SHIFT	303
#define	IDL_RIGHT_SHIFT	304
#define	IDL_SCOPE_DELIMITOR	305
#define	IDL_IDENTIFIER	306
#define	IDL_INTEGER_LITERAL	307
#define	IDL_STRING_LITERAL	308
#define	IDL_WIDE_STRING_LITERAL	309
#define	IDL_CHARACTER_LITERAL	310
#define	IDL_WIDE_CHARACTER_LITERAL	311
#define	IDL_FLOATING_PT_LITERAL	312
#define	IDL_FIXED_PT_LITERAL	313
#define	IDL_FALSE	314
#define	IDL_TRUE	315
#define	IDL_PRAGMA	316


extern YYSTYPE yylval;
