// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef IFR1_IMPL_H
#define IFR1_IMPL_H

#include <OB/NativeTypes.h>
#include <OB/POA.h>
#include <OB/POAServantBase.h>
#include <OB/IFR1_skel.h>

namespace CORBA
{

//
// The IRObject_impl class
//
class IRObject_impl : public virtual POA_CORBA::IRObject
{
protected:

    ORB_var orb_;

public:

    IRObject_impl(ORB_ptr);
    virtual ~IRObject_impl();

    virtual void releaseInternal();

    virtual DefinitionKind def_kind()
        throw(SystemException) = 0;
    virtual void destroy()
        throw(SystemException);
};

//
// The IDLType_impl class
//
class IDLType_impl : public virtual POA_CORBA::IDLType,
		     public virtual IRObject_impl
{
public:

    IDLType_impl(ORB_ptr);
    virtual ~IDLType_impl();

    virtual TypeCode_ptr type()
        throw(SystemException) = 0;
    virtual TypeCode_ptr typeRecursive(ContainedSeq&)
        throw(SystemException) = 0;
};

} // End of namespace CORBA

#endif
