// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <Test4_impl.h>

CORBA::Boolean
Test4_impl::opFixedArray(const Test4::FixedArray arr)
    throw(CORBA::SystemException)
{
    for(int i = 0; i < 10; ++i)
	if(arr[i] != i)
	    return false;

    return true;
}

CORBA::Boolean
Test4_impl::opFixedArrayAny(const CORBA::Any& a)
    throw(CORBA::SystemException)
{
    Test4::FixedArray_forany arr;

    if(!(a >>= arr))
	return false;

    //
    // Validate the contents of the array
    //
    for(int i = 0; i < 10; ++i)
	if(arr[i] != i)
	    return false;

    return true;
}


CORBA::Boolean
Test4_impl::opFixedArraySequence(const Test4::FixedArraySequence& seq)
    throw(CORBA::SystemException)
{
    for(int i = 0; i < 10; ++i)
	if(seq[0][i] != i)
	    return false;

    return true;
}

CORBA::Boolean
Test4_impl::opFixedArraySequenceAny(const CORBA::Any& a)
    throw(CORBA::SystemException)
{
    Test4::FixedArraySequence* seq;
    if(!(a >>= seq))
	return false;

    if(seq -> length() != 1)
	return false;

    //
    // Validate the contents of the array
    //
    for(int i = 0; i < 10; ++i)
	if((*seq)[0][i] != i)
	    return false;

    return true;
}

CORBA::Boolean
Test4_impl::opFixedArray2(const Test4::FixedArray2 arr)
    throw(CORBA::SystemException)
{
    for(int i = 0; i < 2; ++i)
	for(int j = 0; j < 3; ++j)
	    for(int k = 0; k < 4; ++k)
		if(arr[i][j][k] != i+j+k)
		    return false;
    return true;
}

CORBA::Boolean
Test4_impl::opFixedArray2Any(const CORBA::Any& a)
    throw(CORBA::SystemException)
{
    Test4::FixedArray2_forany arr;

    if(!(a >>= arr))
	return false;

    for(int i = 0; i < 2; ++i)
	for(int j = 0; j < 3; ++j)
	    for(int k = 0; k < 4; ++k)
		if(arr[i][j][k] != i+j+k)
		    return false;

    return true;
}


CORBA::Boolean
Test4_impl::opFixedArraySequence2(const Test4::FixedArraySequence2& seq)
    throw(CORBA::SystemException)
{
    if(seq.length() != 1)
	return false;

    for(int i = 0; i < 2; ++i)
	for(int j = 0; j < 3; ++j)
	    for(int k = 0; k < 4; ++k)
		if(seq[0][i][j][k] != i+j+k)
		    return false;

    return true;
}

CORBA::Boolean
Test4_impl::opFixedArraySequence2Any(const CORBA::Any& a)
    throw(CORBA::SystemException)
{
    Test4::FixedArraySequence2* seq;
    if(!(a >>= seq))
	return false;

    if(seq -> length() != 1)
	return false;

    for(int i = 0; i < 2; ++i)
	for(int j = 0; j < 3; ++j)
	    for(int k = 0; k < 4; ++k)
		if((*seq)[0][i][j][k] != i+j+k)
		    return false;

    return true;
}

