// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/CONV_FRAME.h>
#include <OB/CodeSetUtil.h>
#include <OB/CodeSetDatabase.h>
#include <OB/CodeConverter.h>

#include <TestMacro.h>

#define SIZE 1024 // More than sufficient for our tests

using namespace CORBA;
using namespace OB;

void
TestConverter()
{
    Octet buf[SIZE];

    CodeSetDatabase* db = CodeSetDatabase::instance();
    CodeConverters* converters = new CodeConverters;

    converters -> wcharConverter = new CodeConverter(
	db -> getCodeSetInfo(CodeSetDatabase::ISOLATIN1),
	db -> getCodeSetInfo(CodeSetDatabase::UTF8));

    {
	InputStream in(converters, buf, 0, SIZE, false);
	OutputStream out(converters, buf, 0, SIZE);

	WChar v, vSave;

	v = L'a';
	vSave = v;
	out.write_wchar(v);
	v = in.read_wchar();
	TEST(v == vSave);
    }

    {
	InputStream in(converters, buf, 0, SIZE, false);
	OutputStream out(converters, buf, 0, SIZE);

	WString_var v, vSave;

	v = wstring_dup(L"Hello, world!");
	vSave = v;
	out.write_wstring(v);
	v = in.read_wstring();
	TEST(!OB::wcscmp(v, vSave));
    }
}
