// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/CONV_FRAME.h>
#include <OB/CodeSetUtil.h>

#include <TestMacro.h>

#define SIZE 1024 // More than sufficient for our tests

using namespace CORBA;
using namespace OB;

void
TestUTF8()
{
    Octet buf[SIZE];
    Octet* in = buf;
    Octet* out = buf;

    WChar wc, wcSave;

    //
    // 7 free bits
    //
    wc = L'a';
    wcSave = wc;
    CodeSetUtil::unicodeToUtf8(out, wc);
    wc = CodeSetUtil::utf8ToUnicode(in);
    TEST(wc == wcSave);

    //
    // 5 free bits
    //
    wc = 0x80;
    wcSave = wc;
    CodeSetUtil::unicodeToUtf8(out, wc);
    wc = CodeSetUtil::utf8ToUnicode(in);
    TEST(wc == wcSave);

    //
    // 5 free bits
    //
    wc = 0x678;
    wcSave = wc;
    CodeSetUtil::unicodeToUtf8(out, wc);
    wc = CodeSetUtil::utf8ToUnicode(in);
    TEST(wc == wcSave);

    //
    // 4 free bits
    //
    wc = 0x20ac; // Euro symbol
    wcSave = wc;
    CodeSetUtil::unicodeToUtf8(out, wc);
    wc = CodeSetUtil::utf8ToUnicode(in);
    TEST(wc == wcSave);

#if SIZEOF_WCHAR > 2

    //
    // 3 free bits
    //
    wc = 0x12345;
    wcSave = wc;
    CodeSetUtil::unicodeToUtf8(out, wc);
    wc = CodeSetUtil::utf8ToUnicode(in);
    TEST(wc == wcSave);

    //
    // 2 free bits
    //
    wc = 0x3456789;
    wcSave = wc;
    CodeSetUtil::unicodeToUtf8(out, wc);
    wc = CodeSetUtil::utf8ToUnicode(in);
    TEST(wc == wcSave);

    //
    // 1 free bit
    //
    wc = 0x12345678;
    wcSave = wc;
    CodeSetUtil::unicodeToUtf8(out, wc);
    wc = CodeSetUtil::utf8ToUnicode(in);
    TEST(wc == wcSave);

#endif
}

