# **********************************************************************
#
# Copyright (c) 1998
# Object-Oriented Concepts, Inc.
# Billerica, MA, USA
#
# Copyright (c) 1998
# Object-Oriented Concepts GmbH
# Ettlingen, Germany
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

LIB_NAME	= $(top_srcdir)\lib\obtestmain.lib
SERVER_NAME	= server.exe
CLIENT_NAME	= client.exe

TARGETS		= $(LIB_NAME) \
		  $(SERVER_NAME) \
		  $(CLIENT_NAME)

!include $(top_srcdir)\config\Make.rules.mak

LIB_OBJS	= TestInterface.obj \
		  TestInterface_skel.obj \
		  TestInterfaceEx.obj \
		  TestInterfaceEx_skel.obj \
		  TestInterfaceTimeout.obj \
		  TestInterfaceTimeout_skel.obj \
		  Test_impl.obj \
		  TestDSI_impl.obj \
		  TestStub.obj \
		  TestStubContext.obj \
		  TestStubException.obj \
		  TestStubTimeout.obj \
		  TestDII.obj \
		  TestDIIContext.obj \
		  TestDIIException.obj \
		  Server.obj \
		  Client.obj

SERVER_OBJS	= ServerMain.obj

CLIENT_OBJS	= ClientMain.obj

ALL_CXXFLAGS	= $(CXXFLAGS)
ALL_CPPFLAGS	= /I. /I..\common $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_LIBS	= $(LIB_NAME) $(top_srcdir)\lib\obtestcommon.lib \
		  $(OB_LIBS) $(LIBS)

$(LIB_NAME): $(LIB_OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

$(SERVER_NAME): $(SERVER_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(SERVER_OBJS) $(ALL_LIBS)

$(CLIENT_NAME): $(CLIENT_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(CLIENT_OBJS) $(ALL_LIBS)

TestInterface.cpp TestInterface.h: TestInterface.idl
	del /q TestInterface.cpp TestInterface.h
	$(IDL) --tie TestInterface.idl

TestInterface_skel.cpp TestInterface_skel.h TestInterface_skel_tie.h: \
							TestInterface.cpp

TestInterfaceEx.cpp TestInterfaceEx.h: TestInterfaceEx.idl
	del /q TestInterfaceEx.cpp TestInterfaceEx.h
	$(IDL) -I. --tie TestInterfaceEx.idl

TestInterfaceEx_skel.cpp TestInterfaceEx_skel.h TestInterfaceEx_skel_tie.h: \
							TestInterfaceEx.cpp

TestInterfaceTimeout.cpp TestInterfaceTimeout.h: TestInterfaceTimeout.idl
	del /q TestInterfaceTimeout.cpp TestInterfaceTimeout.h
	$(IDL) -I. --tie TestInterfaceTimeout.idl

TestInterfaceTimeout_skel.cpp TestInterfaceTimeout_skel.h \
					TestInterfaceTimeout_skel_tie.h: \
					TestInterfaceTimeout.cpp

install:: all
	$(INSTALL_DATA) $(LIB_NAME) $(libdir)

!include .windep
