// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/OBPolicies.h>
#include <OB/Util.h>

#include <TestInterfaceTimeout.h>
#include <TestMacro.h>

#ifdef HAVE_UNISTD_H
#   include <unistd.h>
#endif

using namespace CORBA;

void
TestStubTimeout(ORB_ptr orb, TestInterfaceTimeout_ptr tiOriginal)
{
    //
    // Create policy list containing new timeout policy
    //
    PolicyList pl(1);
    pl.length(1);
    Any any;
    any <<= (ULong)2000;
    pl[0] = orb -> create_policy(OB::TIMEOUT_POLICY, any);
    
    //
    // _set_policy_overrides returns new proxy, which this policy
    // applied.
    //
    Object_var obj = tiOriginal -> _set_policy_overrides(pl, ADD_OVERRIDE);
    //
    // _narrow to correct type
    //
    TestInterfaceTimeout_var ti = TestInterfaceTimeout::_narrow(obj);
    assert(!is_nil(ti));
    
    ti -> sleepOneway(3);

    try
    {
	ti -> sleepTwoway(0);
	TEST(false);
    }
    catch(const NO_RESPONSE&)
    {
    }

#ifdef WIN32
    Sleep(2000);
#else
    sleep(2);
#endif

    try
    {
	ti -> sleepTwoway(0);
    }
    catch(const NO_RESPONSE&)
    {
	TEST(false);
    }
}
