// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef TEST_IMPL_H
#define TEST_IMPL_H

#include <TestInterface_skel.h>
#include <TestInterfaceEx_skel.h>
#include <TestInterfaceTimeout_skel.h>

class TestInterface_impl : virtual public POA_TestInterface
{
    CORBA::ORB_var orb_;

protected:

    CORBA::Short aShort;
    CORBA::UShort aUShort;
    CORBA::Long aLong;
    CORBA::ULong aULong;
    CORBA::LongLong aLongLong;
    CORBA::ULongLong aULongLong;
    CORBA::Float aFloat;
    CORBA::Double aDouble;
    CORBA::LongDouble aLongDouble;
    TestInterface::TestFixed aFixed;
    CORBA::Boolean aBoolean;
    CORBA::Char aChar;
    CORBA::WChar aWChar;
    CORBA::Octet aOctet;
    CORBA::String_var aString;
    CORBA::WString_var aWString;
    CORBA::Any aAny;
    TestInterface::TestEnum aTestEnum;
    TestInterface_var aTestInterface;
    TestInterface::FixedStruct aFixedStruct;
    TestInterface::VariableStruct aVariableStruct;
    TestInterface::FixedUnion aFixedUnion;
    TestInterface::VariableUnion aVariableUnion;
    TestInterface::StringSequence aStringSequence;
    TestInterface::FixedArray aFixedArray;
    TestInterface::VariableArray aVariableArray;
    TestInterface::FixedArraySequence aFixedArraySequence;
    TestInterface::VariableArraySequence aVariableArraySequence;

public:
    TestInterface_impl(CORBA::ORB_ptr);

    virtual void opVoid()
	throw(CORBA::SystemException);
    
    virtual TestInterface::StringSequence* opContext(const char*,
						     CORBA::Context_ptr)
	throw(CORBA::SystemException);

    virtual CORBA::Short attrShort()
	throw(CORBA::SystemException);
    virtual void attrShort(CORBA::Short)
	throw(CORBA::SystemException);

    virtual CORBA::Short opShort(CORBA::Short a0,
				 CORBA::Short& a1,
				 CORBA::Short& a2)
	throw(CORBA::SystemException);

    virtual CORBA::Long attrLong()
	throw(CORBA::SystemException);
    virtual void attrLong(CORBA::Long)
	throw(CORBA::SystemException);

    virtual CORBA::Long opLong(CORBA::Long a0,
			       CORBA::Long& a1,
			       CORBA::Long& a2)
	throw(CORBA::SystemException);

    virtual CORBA::LongLong attrLongLong()
	throw(CORBA::SystemException);
    virtual void attrLongLong(CORBA::LongLong)
	throw(CORBA::SystemException);

    virtual CORBA::LongLong opLongLong(CORBA::LongLong a0,
				       CORBA::LongLong& a1,
				       CORBA::LongLong& a2)
	throw(CORBA::SystemException);

    virtual CORBA::UShort attrUShort()
	throw(CORBA::SystemException);
    virtual void attrUShort(CORBA::UShort)
	throw(CORBA::SystemException);

    virtual CORBA::UShort opUShort(CORBA::UShort a0,
				   CORBA::UShort& a1,
				   CORBA::UShort& a2)
	throw(CORBA::SystemException);

    virtual CORBA::ULong attrULong()
	throw(CORBA::SystemException);
    virtual void attrULong(CORBA::ULong)
	throw(CORBA::SystemException);

    virtual CORBA::ULong opULong(CORBA::ULong a0,
				 CORBA::ULong& a1,
				 CORBA::ULong& a2)
	throw(CORBA::SystemException);

    virtual CORBA::ULongLong attrULongLong()
	throw(CORBA::SystemException);
    virtual void attrULongLong(CORBA::ULongLong)
	throw(CORBA::SystemException);

    virtual CORBA::ULongLong opULongLong(CORBA::ULongLong a0,
					 CORBA::ULongLong& a1,
					 CORBA::ULongLong& a2)
	throw(CORBA::SystemException);

    virtual CORBA::Float attrFloat()
	throw(CORBA::SystemException);
    virtual void attrFloat(CORBA::Float)
	throw(CORBA::SystemException);

    virtual CORBA::Float opFloat(CORBA::Float a0,
				 CORBA::Float& a1,
				 CORBA::Float& a2)
	throw(CORBA::SystemException);

    virtual CORBA::Double attrDouble()
	throw(CORBA::SystemException);
    virtual void attrDouble(CORBA::Double)
	throw(CORBA::SystemException);

    virtual CORBA::Double opDouble(CORBA::Double a0,
				   CORBA::Double& a1,
				   CORBA::Double& a2)
	throw(CORBA::SystemException);

    virtual CORBA::LongDouble attrLongDouble()
	throw(CORBA::SystemException);
    virtual void attrLongDouble(CORBA::LongDouble)
	throw(CORBA::SystemException);

    virtual CORBA::LongDouble opLongDouble(CORBA::LongDouble a0,
					   CORBA::LongDouble& a1,
					   CORBA::LongDouble& a2)
	throw(CORBA::SystemException);

    virtual TestInterface::TestFixed attrFixed()
	throw(CORBA::SystemException);
    virtual void attrFixed(TestInterface::TestFixed)
	throw(CORBA::SystemException);

    virtual TestInterface::TestFixed opFixed(TestInterface::TestFixed a0,
					     TestInterface::TestFixed& a1,
					     TestInterface::TestFixed_out a2)
	throw(CORBA::SystemException);

    virtual CORBA::Boolean attrBoolean()
	throw(CORBA::SystemException);
    virtual void attrBoolean(CORBA::Boolean)
	throw(CORBA::SystemException);

    virtual CORBA::Boolean opBoolean(CORBA::Boolean a0,
				     CORBA::Boolean& a1,
				     CORBA::Boolean& a2)
	throw(CORBA::SystemException);
    
    virtual CORBA::Char attrChar()
	throw(CORBA::SystemException);
    virtual void attrChar(CORBA::Char)
	throw(CORBA::SystemException);
    
    virtual CORBA::Char opChar(CORBA::Char a0,
			       CORBA::Char& a1,
			       CORBA::Char& a2)
	throw(CORBA::SystemException);
    
    virtual CORBA::WChar attrWChar()
	throw(CORBA::SystemException);
    virtual void attrWChar(CORBA::WChar)
	throw(CORBA::SystemException);
    
    virtual CORBA::WChar opWChar(CORBA::WChar a0,
				 CORBA::WChar& a1,
				 CORBA::WChar& a2)
	throw(CORBA::SystemException);

    virtual CORBA::Octet attrOctet()
	throw(CORBA::SystemException);
    virtual void attrOctet(CORBA::Octet)
	throw(CORBA::SystemException);

    virtual CORBA::Octet opOctet(CORBA::Octet a0,
				 CORBA::Octet& a1,
				 CORBA::Octet& a2)
	throw(CORBA::SystemException);

    virtual char* attrString()
	throw(CORBA::SystemException);
    virtual void attrString(const char*)
	throw(CORBA::SystemException);
    
    virtual char* opString(const char* a0,
                           char*& a1,
                           CORBA::String_out a2)
	throw(CORBA::SystemException);

    virtual wchar_t* attrWString()
	throw(CORBA::SystemException);
    virtual void attrWString(const wchar_t*)
	throw(CORBA::SystemException);

    virtual wchar_t* opWString(const wchar_t* a0,
			       wchar_t*& a1,
			       CORBA::WString_out a2)
	throw(CORBA::SystemException);

    virtual CORBA::Any* attrAny()
	throw(CORBA::SystemException);
    virtual void attrAny(const CORBA::Any&)
	throw(CORBA::SystemException);

    virtual CORBA::Any* opAny(const CORBA::Any& a0,
			      CORBA::Any& a1,
			      CORBA::Any_out a2)
	throw(CORBA::SystemException);

    virtual TestInterface::TestEnum attrTestEnum()
	throw(CORBA::SystemException);
    virtual void attrTestEnum(TestInterface::TestEnum)
	throw(CORBA::SystemException);

    virtual TestInterface::TestEnum opTestEnum(TestInterface::TestEnum a0,
                                               TestInterface::TestEnum& a1,
                                               TestInterface::TestEnum& a2)
	throw(CORBA::SystemException);

    virtual TestInterface_ptr attrTestInterface()
	throw(CORBA::SystemException);
    virtual void attrTestInterface(TestInterface_ptr)
	throw(CORBA::SystemException);

    virtual TestInterface_ptr
    opTestInterface(TestInterface_ptr a0,
                    TestInterface_ptr& a1,
                    TestInterface_out a2)
	throw(CORBA::SystemException);
    
    virtual TestInterface::FixedStruct attrFixedStruct()
	throw(CORBA::SystemException);
    virtual void attrFixedStruct(const TestInterface::FixedStruct&)
	throw(CORBA::SystemException);

    virtual TestInterface::FixedStruct
    opFixedStruct(const TestInterface::FixedStruct& a0,
                  TestInterface::FixedStruct& a1,
                  TestInterface::FixedStruct& a2)
	throw(CORBA::SystemException);

    virtual TestInterface::VariableStruct* attrVariableStruct()
	throw(CORBA::SystemException);
    virtual void attrVariableStruct(const TestInterface::VariableStruct&)
	throw(CORBA::SystemException);

    virtual TestInterface::VariableStruct*
    opVariableStruct(const TestInterface::VariableStruct& a0,
                     TestInterface::VariableStruct& a1,
                     TestInterface::VariableStruct_out a2)
	throw(CORBA::SystemException);

    virtual TestInterface::FixedUnion attrFixedUnion()
	throw(CORBA::SystemException);
    virtual void attrFixedUnion(const TestInterface::FixedUnion&)
	throw(CORBA::SystemException);

    virtual TestInterface::FixedUnion
    opFixedUnion(const TestInterface::FixedUnion& a0,
                 TestInterface::FixedUnion& a1,
                 TestInterface::FixedUnion& a2)
	throw(CORBA::SystemException);

    virtual TestInterface::VariableUnion* attrVariableUnion()
	throw(CORBA::SystemException);
    virtual void attrVariableUnion(const TestInterface::VariableUnion&)
	throw(CORBA::SystemException);

    virtual TestInterface::VariableUnion*
    opVariableUnion(const TestInterface::VariableUnion& a0,
                    TestInterface::VariableUnion& a1,
                    TestInterface::VariableUnion_out a2)
	throw(CORBA::SystemException);

    virtual TestInterface::StringSequence* attrStringSequence()
	throw(CORBA::SystemException);
    virtual void attrStringSequence(const TestInterface::StringSequence&)
	throw(CORBA::SystemException);

    virtual TestInterface::StringSequence*
    opStringSequence(const TestInterface::StringSequence& a0,
                     TestInterface::StringSequence& a1,
                     TestInterface::StringSequence_out a2)
	throw(CORBA::SystemException);

    virtual TestInterface::FixedArray_slice* attrFixedArray()
	throw(CORBA::SystemException);
    virtual void attrFixedArray(const TestInterface::FixedArray)
	throw(CORBA::SystemException);

    virtual TestInterface::FixedArray_slice*
    opFixedArray(const TestInterface::FixedArray a0,
                 TestInterface::FixedArray a1,
                 TestInterface::FixedArray a2)
	throw(CORBA::SystemException);

    virtual TestInterface::VariableArray_slice* attrVariableArray()
	throw(CORBA::SystemException);
    virtual void attrVariableArray(const TestInterface::VariableArray)
	throw(CORBA::SystemException);

    virtual TestInterface::VariableArray_slice*
    opVariableArray(const TestInterface::VariableArray a0,
                    TestInterface::VariableArray a1,
                    TestInterface::VariableArray_out a2)
	throw(CORBA::SystemException);

    virtual TestInterface::FixedArraySequence* attrFixedArraySequence()
	throw(CORBA::SystemException);
    virtual void attrFixedArraySequence(
        const TestInterface::FixedArraySequence&)
	    throw(CORBA::SystemException);

    virtual TestInterface::FixedArraySequence*
    opFixedArraySequence(const TestInterface::FixedArraySequence& a0,
			 TestInterface::FixedArraySequence& a1,
			 TestInterface::FixedArraySequence_out a2)
	throw(CORBA::SystemException);

    virtual TestInterface::VariableArraySequence* attrVariableArraySequence()
	throw(CORBA::SystemException);
    virtual void attrVariableArraySequence(
        const TestInterface::VariableArraySequence&)
	    throw(CORBA::SystemException);

    virtual TestInterface::VariableArraySequence*
    opVariableArraySequence(const TestInterface::VariableArraySequence& a0,
			    TestInterface::VariableArraySequence& a1,
			    TestInterface::VariableArraySequence_out a2)
	throw(CORBA::SystemException);

    virtual void releaseInternal();
    
    virtual void deactivate()
	throw(CORBA::SystemException);
};

class TestInterfaceEx_impl : virtual public POA_TestInterfaceEx,
			     virtual public TestInterface_impl
{
public:
    TestInterfaceEx_impl(CORBA::ORB_ptr);
    
    virtual void opVoidEx()
        throw(TestInterfaceEx::ExVoid,
              CORBA::SystemException);

    virtual CORBA::Short opShortEx(CORBA::Short a0,
				  CORBA::Short& a1,
				  CORBA::Short& a2)
    throw(TestInterfaceEx::ExShort,
	  CORBA::SystemException);

    virtual CORBA::Long opLongEx(CORBA::Long a0,
				CORBA::Long& a1,
				CORBA::Long& a2)
	throw(TestInterfaceEx::ExLong,
	      CORBA::SystemException);

    virtual CORBA::LongLong opLongLongEx(CORBA::LongLong a0,
					CORBA::LongLong& a1,
					CORBA::LongLong&)
	throw(TestInterfaceEx::ExLongLong,
	      CORBA::SystemException);

    virtual CORBA::ULongLong opULongLongEx(CORBA::ULongLong a0,
					  CORBA::ULongLong& a1,
					  CORBA::ULongLong&)
	throw(TestInterfaceEx::ExULongLong,
	      CORBA::SystemException);

    virtual CORBA::UShort opUShortEx(CORBA::UShort a0,
				    CORBA::UShort& a1,
				    CORBA::UShort& a2)
	throw(TestInterfaceEx::ExUShort,
	      CORBA::SystemException);

    virtual CORBA::ULong opULongEx(CORBA::ULong a0,
				  CORBA::ULong& a1,
				  CORBA::ULong& a2)
	throw(TestInterfaceEx::ExULong,
	      CORBA::SystemException);

    virtual CORBA::Float opFloatEx(CORBA::Float a0,
				  CORBA::Float& a1,
				  CORBA::Float& a2)
	throw(TestInterfaceEx::ExFloat,
	      CORBA::SystemException);

    virtual CORBA::Double opDoubleEx(CORBA::Double a0,
				    CORBA::Double& a1,
				    CORBA::Double& a2)
	throw(TestInterfaceEx::ExDouble,
	      CORBA::SystemException);

    virtual CORBA::LongDouble opLongDoubleEx(CORBA::LongDouble a0,
					    CORBA::LongDouble& a1,
					    CORBA::LongDouble& a2)
	throw(TestInterfaceEx::ExLongDouble,
	      CORBA::SystemException);

    virtual TestInterface::TestFixed opFixedEx(TestInterface::TestFixed a0,
					       TestInterface::TestFixed& a1,
					       TestInterface::TestFixed_out a2)
	throw(TestInterfaceEx::ExFixed,
	      CORBA::SystemException);

    virtual CORBA::Boolean opBooleanEx(CORBA::Boolean a0,
				      CORBA::Boolean& a1,
				      CORBA::Boolean& a2)
	throw(TestInterfaceEx::ExBoolean,
	      CORBA::SystemException);
    
    virtual CORBA::Char opCharEx(CORBA::Char a0,
				CORBA::Char& a1,
				CORBA::Char& a2)
	throw(TestInterfaceEx::ExChar,
	      CORBA::SystemException);

    virtual CORBA::WChar opWCharEx(CORBA::WChar a0,
				  CORBA::WChar& a1,
				  CORBA::WChar& a2)
	throw(TestInterfaceEx::ExWChar,
	      CORBA::SystemException);

    virtual CORBA::Octet opOctetEx(CORBA::Octet a0,
				  CORBA::Octet& a1,
				  CORBA::Octet& a2)
	throw(TestInterfaceEx::ExOctet,
	      CORBA::SystemException);

    virtual char* opStringEx(const char* a0,
			     char*& a1,
			     CORBA::String_out a2)
	throw(TestInterfaceEx::ExString,
	      CORBA::SystemException);

    virtual wchar_t* opWStringEx(const wchar_t* a0,
				 wchar_t*& a1,
				 CORBA::WString_out a2)
	throw(TestInterfaceEx::ExWString,
	      CORBA::SystemException);

    virtual CORBA::Any* opAnyEx(const CORBA::Any& a0,
			       CORBA::Any& a1,
			       CORBA::Any_out a2)
	throw(TestInterfaceEx::ExAny,
	      CORBA::SystemException);

    virtual TestInterface::TestEnum opTestEnumEx(TestInterface::TestEnum a0,
                                                 TestInterface::TestEnum& a1,
                                                 TestInterface::TestEnum& a2)
	throw(TestInterfaceEx::ExTestEnum,
	      CORBA::SystemException);

    virtual TestInterface_ptr
    opTestInterfaceEx(TestInterface_ptr a0,
                      TestInterface_ptr& a1,
                      TestInterface_out a2)
	throw(TestInterfaceEx::ExTestInterface,
	      CORBA::SystemException);
    
    virtual TestInterface::FixedStruct
    opFixedStructEx(const TestInterface::FixedStruct& a0,
                    TestInterface::FixedStruct& a1,
                    TestInterface::FixedStruct& a2)
	throw(TestInterfaceEx::ExFixedStruct,
	      CORBA::SystemException);

    virtual TestInterface::VariableStruct*
    opVariableStructEx(const TestInterface::VariableStruct& a0,
                       TestInterface::VariableStruct& a1,
                       TestInterface::VariableStruct_out a2)
	throw(TestInterfaceEx::ExVariableStruct,
	      CORBA::SystemException);

    virtual TestInterface::FixedUnion
    opFixedUnionEx(const TestInterface::FixedUnion& a0,
                   TestInterface::FixedUnion& a1,
                   TestInterface::FixedUnion& a2)
	throw(TestInterfaceEx::ExFixedUnion,
	      CORBA::SystemException);

    virtual TestInterface::VariableUnion*
    opVariableUnionEx(const TestInterface::VariableUnion& a0,
                      TestInterface::VariableUnion& a1,
                      TestInterface::VariableUnion_out a2)
	throw(TestInterfaceEx::ExVariableUnion,
	      CORBA::SystemException);

    virtual TestInterface::StringSequence*
    opStringSequenceEx(const TestInterface::StringSequence& a0,
                       TestInterface::StringSequence& a1,
                       TestInterface::StringSequence_out a2)
	throw(TestInterfaceEx::ExStringSequence,
	      CORBA::SystemException);

    virtual TestInterface::FixedArray_slice*
    opFixedArrayEx(const TestInterface::FixedArray a0,
                   TestInterface::FixedArray a1,
                   TestInterface::FixedArray a2)
	throw(TestInterfaceEx::ExFixedArray,
	      CORBA::SystemException);

    virtual TestInterface::VariableArray_slice*
    opVariableArrayEx(const TestInterface::VariableArray a0,
                      TestInterface::VariableArray a1,
                      TestInterface::VariableArray_out a2)
	throw(TestInterfaceEx::ExVariableArray,
	      CORBA::SystemException);

    virtual TestInterface::FixedArraySequence*
    opFixedArraySequenceEx(const TestInterface::FixedArraySequence& a0,
			   TestInterface::FixedArraySequence& a1,
			   TestInterface::FixedArraySequence_out a2)
	throw(TestInterfaceEx::ExFixedArraySequence,
	      CORBA::SystemException);

    virtual TestInterface::VariableArraySequence*
    opVariableArraySequenceEx(const TestInterface::VariableArraySequence& a0,
			      TestInterface::VariableArraySequence& a1,
			      TestInterface::VariableArraySequence_out a2)
	throw(TestInterfaceEx::ExVariableArraySequence,
	      CORBA::SystemException);

    virtual void op_UNKNOWN_Ex()
	throw(CORBA::SystemException);
    virtual void op_BAD_PARAM_Ex()
	throw(CORBA::SystemException);
    virtual void op_NO_MEMORY_Ex()
	throw(CORBA::SystemException);
    virtual void op_IMP_LIMIT_Ex()
	throw(CORBA::SystemException);
    virtual void op_COMM_FAILURE_Ex()
	throw(CORBA::SystemException);
    virtual void op_INV_OBJREF_Ex()
	throw(CORBA::SystemException);
    virtual void op_NO_PERMISSION_Ex()
	throw(CORBA::SystemException);
    virtual void op_INTERNAL_Ex()
	throw(CORBA::SystemException);
    virtual void op_MARSHAL_Ex()
	throw(CORBA::SystemException);
    virtual void op_INITIALIZE_Ex()
	throw(CORBA::SystemException);
    virtual void op_NO_IMPLEMENT_Ex()
	throw(CORBA::SystemException);
    virtual void op_BAD_TYPECODE_Ex()
	throw(CORBA::SystemException);
    virtual void op_BAD_OPERATION_Ex()
	throw(CORBA::SystemException);
    virtual void op_NO_RESOURCES_Ex()
	throw(CORBA::SystemException);
    virtual void op_NO_RESPONSE_Ex()
	throw(CORBA::SystemException);
    virtual void op_PERSIST_STORE_Ex()
	throw(CORBA::SystemException);
    virtual void op_BAD_INV_ORDER_Ex()
	throw(CORBA::SystemException);
    virtual void op_TRANSIENT_Ex()
	throw(CORBA::SystemException);
    virtual void op_FREE_MEM_Ex()
	throw(CORBA::SystemException);
    virtual void op_INV_IDENT_Ex()
	throw(CORBA::SystemException);
    virtual void op_INV_FLAG_Ex()
	throw(CORBA::SystemException);
    virtual void op_INTF_REPOS_Ex()
	throw(CORBA::SystemException);
    virtual void op_BAD_CONTEXT_Ex()
	throw(CORBA::SystemException);
    virtual void op_OBJ_ADAPTER_Ex()
	throw(CORBA::SystemException);
    virtual void op_DATA_CONVERSION_Ex()
	throw(CORBA::SystemException);
    virtual void op_OBJECT_NOT_EXIST_Ex()
	throw(CORBA::SystemException);
    virtual void op_INV_POLICY_Ex()
	throw(CORBA::SystemException);
    virtual void op_TRANSACTION_REQUIRED_Ex()
	throw(CORBA::SystemException);
    virtual void op_TRANSACTION_ROLLEDBACK_Ex()
	throw(CORBA::SystemException);
    virtual void op_INVALID_TRANSACTION_Ex()
	throw(CORBA::SystemException);
};

class TestInterfaceTimeout_impl : virtual public POA_TestInterfaceTimeout,
				  virtual public TestInterfaceEx_impl
{
public:
    TestInterfaceTimeout_impl(CORBA::ORB_ptr);

    virtual void sleepOneway(CORBA::ULong sec)
        throw(CORBA::SystemException);
    virtual void sleepTwoway(CORBA::ULong sec)
        throw(CORBA::SystemException);
};

#endif
