// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <TestOBV.h>
#include <Factories.h>
#include <TestValue_impl.h>
#include <TestTrunc_impl.h>
#include <TestCustom_impl.h>

using namespace CORBA;

ValueBase*
TestValueFactory_impl::create_for_unmarshal()
{
    return new TestValue_impl;
}

TestValue_init*
TestValueFactory_impl::install(ORB_ptr orb)
{
    TestValueFactory_impl* factory = new TestValueFactory_impl;
    ValueFactoryBase_var old;
    old = orb -> register_value_factory("IDL:TestValue:1.0", factory);
    return factory;
}

TestValue*
TestValueFactory_impl::create(Long l)
{
    TestValue* result = new TestValue_impl;
    result -> count(l);
    return result;
}

ValueBase*
TestValueSubFactory_impl::create_for_unmarshal()
{
    return new TestValueSub_impl;
}

TestValueSub_init*
TestValueSubFactory_impl::install(ORB_ptr orb)
{
    TestValueSubFactory_impl* factory = new TestValueSubFactory_impl;
    ValueFactoryBase_var old;
    old = orb -> register_value_factory("IDL:TestValueSub:1.0", factory);
    return factory;
}

TestValueSub*
TestValueSubFactory_impl::create(Long l, const char* s)
{
    TestValueSub* result = new TestValueSub_impl;
    result -> count(l);
    result -> name(s);
    return result;
}

ValueBase*
TestTruncBaseFactory_impl::create_for_unmarshal()
{
    return new TestTruncBase_impl;
}

void
TestTruncBaseFactory_impl::install(ORB_ptr orb)
{
    TestTruncBaseFactory_impl* factory = new TestTruncBaseFactory_impl;
    ValueFactoryBase_var old;
    old = orb -> register_value_factory("IDL:TestTruncBase:1.0", factory);
}

ValueBase*
TestTrunc1Factory_impl::create_for_unmarshal()
{
    return new TestTrunc1_impl;
}

void
TestTrunc1Factory_impl::install(ORB_ptr orb)
{
    TestTrunc1Factory_impl* factory = new TestTrunc1Factory_impl;
    ValueFactoryBase_var old;
    old = orb -> register_value_factory("IDL:TestTrunc1:1.0", factory);
}

ValueBase*
TestTrunc2Factory_impl::create_for_unmarshal()
{
    return new TestTrunc2_impl;
}

void
TestTrunc2Factory_impl::install(ORB_ptr orb)
{
    TestTrunc2Factory_impl* factory = new TestTrunc2Factory_impl;
    ValueFactoryBase_var old;
    old = orb -> register_value_factory("IDL:TestTrunc2:1.0", factory);
}

ValueBase*
TestCustomFactory_impl::create_for_unmarshal()
{
    return new TestCustom_impl;
}

TestCustom_init*
TestCustomFactory_impl::install(ORB_ptr orb)
{
    TestCustomFactory_impl* factory = new TestCustomFactory_impl;
    ValueFactoryBase_var old;
    old = orb -> register_value_factory("IDL:TestCustom:1.0", factory);
    return factory;
}

TestCustom*
TestCustomFactory_impl::create(Short s, Long l, const char* str, Double d)
{
    TestCustom* result = new TestCustom_impl;
    result -> shortVal(s);
    result -> longVal(l);
    result -> stringVal(str);
    result -> doubleVal(d);
    return result;
}

ValueBase*
TestStringBoxFactory_impl::create_for_unmarshal()
{
    return new TestStringBox;
}

void
TestStringBoxFactory_impl::install(ORB_ptr orb)
{
    // register_value_factory holds a reference to factory
    ValueFactoryBase_var factory = new TestStringBoxFactory_impl;
    ValueFactoryBase_var old;
    old = orb -> register_value_factory("IDL:TestStringBox:1.0", factory);
}

ValueBase*
TestULongBoxFactory_impl::create_for_unmarshal()
{
    return new TestULongBox;
}

void
TestULongBoxFactory_impl::install(ORB_ptr orb)
{
    // register_value_factory holds a reference to factory
    ValueFactoryBase_var factory = new TestULongBoxFactory_impl;
    ValueFactoryBase_var old;
    old = orb -> register_value_factory("IDL:TestULongBox:1.0", factory);
}

ValueBase*
TestFixStructBoxFactory_impl::create_for_unmarshal()
{
    return new TestFixStructBox;
}

void
TestFixStructBoxFactory_impl::install(ORB_ptr orb)
{
    // register_value_factory holds a reference to factory
    ValueFactoryBase_var factory = new TestFixStructBoxFactory_impl;
    ValueFactoryBase_var old;
    old = orb -> register_value_factory("IDL:TestFixStructBox:1.0", factory);
}

ValueBase*
TestVarStructBoxFactory_impl::create_for_unmarshal()
{
    return new TestVarStructBox;
}

void
TestVarStructBoxFactory_impl::install(ORB_ptr orb)
{
    // register_value_factory holds a reference to factory
    ValueFactoryBase_var factory = new TestVarStructBoxFactory_impl;
    ValueFactoryBase_var old;
    old = orb -> register_value_factory("IDL:TestVarStructBox:1.0", factory);
}

ValueBase*
TestFixUnionBoxFactory_impl::create_for_unmarshal()
{
    return new TestFixUnionBox;
}

void
TestFixUnionBoxFactory_impl::install(ORB_ptr orb)
{
    // register_value_factory holds a reference to factory
    ValueFactoryBase_var factory = new TestFixUnionBoxFactory_impl;
    ValueFactoryBase_var old;
    old = orb -> register_value_factory("IDL:TestFixUnionBox:1.0", factory);
}

ValueBase*
TestVarUnionBoxFactory_impl::create_for_unmarshal()
{
    return new TestVarUnionBox;
}

void
TestVarUnionBoxFactory_impl::install(ORB_ptr orb)
{
    // register_value_factory holds a reference to factory
    ValueFactoryBase_var factory = new TestVarUnionBoxFactory_impl;
    ValueFactoryBase_var old;
    old = orb -> register_value_factory("IDL:TestVarUnionBox:1.0", factory);
}

ValueBase*
TestAnonSeqBoxFactory_impl::create_for_unmarshal()
{
    return new TestAnonSeqBox;
}

void
TestAnonSeqBoxFactory_impl::install(ORB_ptr orb)
{
    // register_value_factory holds a reference to factory
    ValueFactoryBase_var factory = new TestAnonSeqBoxFactory_impl;
    ValueFactoryBase_var old;
    old = orb -> register_value_factory("IDL:TestAnonSeqBox:1.0", factory);
}

ValueBase*
TestStringSeqBoxFactory_impl::create_for_unmarshal()
{
    return new TestStringSeqBox;
}

void
TestStringSeqBoxFactory_impl::install(ORB_ptr orb)
{
    // register_value_factory holds a reference to factory
    ValueFactoryBase_var factory = new TestStringSeqBoxFactory_impl;
    ValueFactoryBase_var old;
    old = orb -> register_value_factory("IDL:TestStringSeqBox:1.0", factory);
}
