// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef FACTORIES_H
#define FACTORIES_H

//
// TestValue factory
//
class TestValueFactory_impl : virtual public TestValue_init
{
    //
    // Inherited from CORBA::ValueFactoryBase
    //
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    static TestValue_init* install(CORBA::ORB_ptr);

    virtual TestValue* create(CORBA::Long l);
};

//
// TestValueSub factory
//
class TestValueSubFactory_impl : virtual public TestValueSub_init
{
    //
    // Inherited from CORBA::ValueFactoryBase
    //
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    static TestValueSub_init* install(CORBA::ORB_ptr);

    virtual TestValueSub* create(CORBA::Long l, const char* s);
};

//
// TestTruncBase factory
//
class TestTruncBaseFactory_impl : virtual public CORBA::ValueFactoryBase
{
    //
    // Inherited from CORBA::ValueFactoryBase
    //
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    static void install(CORBA::ORB_ptr);
};

//
// TestTrunc1 factory
//
class TestTrunc1Factory_impl : virtual public CORBA::ValueFactoryBase
{
    //
    // Inherited from CORBA::ValueFactoryBase
    //
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    static void install(CORBA::ORB_ptr);
};

//
// TestTrunc2 factory
//
class TestTrunc2Factory_impl : virtual public CORBA::ValueFactoryBase
{
    //
    // Inherited from CORBA::ValueFactoryBase
    //
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    static void install(CORBA::ORB_ptr);
};

//
// TestCustom factory
//
class TestCustomFactory_impl : virtual public TestCustom_init
{
    //
    // Inherited from CORBA::ValueFactoryBase
    //
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    static TestCustom_init* install(CORBA::ORB_ptr);

    virtual TestCustom* create(CORBA::Short s, CORBA::Long l, const char* str,
                               CORBA::Double d);
};

//
// TestStringBox factory
//
class TestStringBoxFactory_impl : virtual public CORBA::ValueFactoryBase
{
    //
    // Inherited from CORBA::ValueFactoryBase
    //
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    static void install(CORBA::ORB_ptr);
};

//
// TestULongBox factory
//
class TestULongBoxFactory_impl : virtual public CORBA::ValueFactoryBase
{
    //
    // Inherited from CORBA::ValueFactoryBase
    //
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    static void install(CORBA::ORB_ptr);
};

//
// TestFixStructBox factory
//
class TestFixStructBoxFactory_impl : virtual public CORBA::ValueFactoryBase
{
    //
    // Inherited from CORBA::ValueFactoryBase
    //
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    static void install(CORBA::ORB_ptr);
};

//
// TestVarStructBox factory
//
class TestVarStructBoxFactory_impl : virtual public CORBA::ValueFactoryBase
{
    //
    // Inherited from CORBA::ValueFactoryBase
    //
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    static void install(CORBA::ORB_ptr);
};

//
// TestFixUnionBox factory
//
class TestFixUnionBoxFactory_impl : virtual public CORBA::ValueFactoryBase
{
    //
    // Inherited from CORBA::ValueFactoryBase
    //
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    static void install(CORBA::ORB_ptr);
};

//
// TestVarUnionBox factory
//
class TestVarUnionBoxFactory_impl : virtual public CORBA::ValueFactoryBase
{
    //
    // Inherited from CORBA::ValueFactoryBase
    //
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    static void install(CORBA::ORB_ptr);
};

//
// TestAnonSeqBox factory
//
class TestAnonSeqBoxFactory_impl : virtual public CORBA::ValueFactoryBase
{
    //
    // Inherited from CORBA::ValueFactoryBase
    //
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    static void install(CORBA::ORB_ptr);
};

//
// TestStringSeqBox factory
//
class TestStringSeqBoxFactory_impl : virtual public CORBA::ValueFactoryBase
{
    //
    // Inherited from CORBA::ValueFactoryBase
    //
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    static void install(CORBA::ORB_ptr);
};

#endif
