// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/Util.h>

#include <stdlib.h>

#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

using namespace CORBA;
using namespace PortableServer;

int
main(int argc, char* argv[], char*[])
{
    int status;

    try
    {
        //
        // Create ORB and BOA
        //
        ORB_var orb = ORB_init(argc, argv);

	Object_var obj;

	try
	{
	    obj = orb -> resolve_initial_references("RootPOA");
	}
	catch(const ORB::InvalidName&)
	{
	    cerr << "Error: can't resolve `RootPOA'" << endl;
	    exit(1);
	}

	if(is_nil(obj))
	{
	    cerr << "Error: `RootPOA' is a nil object reference" << endl;
	    exit(1);
	}

	POA_var root = POA::_narrow(obj);

	if(is_nil(root))
	{
	    cerr << "Error: `RootPOA' is not a POA object reference" << endl;
	    exit(1);
	}

	//
	// Run tests
	//
	int ServerRun(ORB_ptr, POA_ptr, int, char*[]);
	status = ServerRun(orb, root, argc, argv);
    }
    catch(const SystemException& ex)
    {
	OB::PrintException(ex);
	status = 1;
    }

    return status;
}
