// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#ifndef TEST_OBV_IMPL_H
#define TEST_OBV_IMPL_H

//
// IDL:TestOBV:1.0
//
class TestOBV_impl : virtual public POA_TestOBV
{
    TestOBV_impl(const TestOBV_impl&);
    void operator=(const TestOBV_impl&);

    CORBA::ORB_var orb_;
    TestValue_var value_;
    TestValueSub_var valueSub_;
    TestCustom_var custom_;
    TestAbstract_var absInterface_;
    //TestAbstract_var absValue_;

public:

    TestOBV_impl(CORBA::ORB_ptr, TestValue_init*, TestValueSub_init*,
                 TestCustom_init*, TestAbstract_ptr);
    ~TestOBV_impl();

    //
    // IDL:TestOBV/get_null_valuebase:1.0
    //
    virtual CORBA::ValueBase* get_null_valuebase()
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_null_valuebase:1.0
    //
    virtual void set_null_valuebase(CORBA::ValueBase* v)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_null_valuesub:1.0
    //
    virtual TestValueSub* get_null_valuesub()
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_null_valuesub:1.0
    //
    virtual void set_null_valuesub(TestValueSub* v)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_abs_value1:1.0
    //
    virtual TestAbsValue1* get_abs_value1()
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_abs_value1:1.0
    //
    virtual void set_abs_value1(TestAbsValue1* v)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_abs_value2:1.0
    //
    virtual TestAbsValue2* get_abs_value2()
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_abs_value2:1.0
    //
    virtual void set_abs_value2(TestAbsValue2* v)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_value:1.0
    //
    virtual TestValue* get_value()
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_value:1.0
    //
    virtual void set_value(TestValue* v)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_valuesub:1.0
    //
    virtual TestValueSub* get_valuesub()
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_valuesub:1.0
    //
    virtual void set_valuesub(TestValueSub* v)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_valuesub_as_value:1.0
    //
    virtual TestValue* get_valuesub_as_value()
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_valuesub_as_value:1.0
    //
    virtual void set_valuesub_as_value(TestValue* v)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_two_values:1.0
    //
    virtual void get_two_values(TestValue*& v1, TestValue*& v2)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_two_values:1.0
    //
    virtual void set_two_values(TestValue* v1, TestValue* v2)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_two_valuesubs_as_values:1.0
    //
    virtual void get_two_valuesubs_as_values(TestValue*& v1, TestValue*& v2)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_two_valuesubs_as_values:1.0
    //
    virtual void set_two_valuesubs_as_values(TestValue* v1, TestValue* v2)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_custom:1.0
    //
    virtual TestCustom* get_custom()
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_custom:1.0
    //
    virtual void set_custom(TestCustom* v)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_abs_custom:1.0
    //
    virtual TestAbsValue1* get_abs_custom()
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_abs_custom:1.0
    //
    virtual void set_abs_custom(TestAbsValue1* v)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_string_box:1.0
    //
    virtual TestStringBox* get_string_box(const char* value)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_string_box:1.0
    //
    virtual void set_string_box(TestStringBox* b, const char* value)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_ulong_box:1.0
    //
    virtual TestULongBox* get_ulong_box(CORBA::ULong value)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_ulong_box:1.0
    //
    virtual void set_ulong_box(TestULongBox* b, CORBA::ULong value)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_fix_struct_box:1.0
    //
    virtual TestFixStructBox* get_fix_struct_box(const TestFixStruct& value)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_fix_struct_box:1.0
    //
    virtual void set_fix_struct_box(TestFixStructBox* b,
                                    const TestFixStruct& value)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_var_struct_box:1.0
    //
    virtual TestVarStructBox* get_var_struct_box(const TestVarStruct& value)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_var_struct_box:1.0
    //
    virtual void set_var_struct_box(TestVarStructBox* b,
                                    const TestVarStruct& value)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_fix_union_box:1.0
    //
    virtual TestFixUnionBox* get_fix_union_box(const TestFixUnion& value)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_fix_union_box:1.0
    //
    virtual void set_fix_union_box(TestFixUnionBox* b,
                                   const TestFixUnion& value)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_var_union_box:1.0
    //
    virtual TestVarUnionBox* get_var_union_box(const TestVarUnion& value)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_var_union_box:1.0
    //
    virtual void set_var_union_box(TestVarUnionBox* b,
                                   const TestVarUnion& value)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_anon_seq_box:1.0
    //
    virtual TestAnonSeqBox* get_anon_seq_box(CORBA::ULong length)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_anon_seq_box:1.0
    //
    virtual void set_anon_seq_box(TestAnonSeqBox* b, CORBA::ULong length)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_string_seq_box:1.0
    //
    virtual TestStringSeqBox* get_string_seq_box(const TestStringSeq& value)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_string_seq_box:1.0
    //
    virtual void set_string_seq_box(TestStringSeqBox* b,
                                    const TestStringSeq& value)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_ai_interface:1.0
    //
    virtual TestAbstract_ptr get_ai_interface()
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_ai_interface:1.0
    //
    virtual void set_ai_interface(TestAbstract_ptr)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_ai_interface_any:1.0
    //
    virtual CORBA::Any* get_ai_interface_any()
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/set_ai_interface_any:1.0
    //
    virtual void set_ai_interface_any(const CORBA::Any&)
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_trunc1:1.0
    //
    virtual TestTruncBase* get_trunc1()
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/get_trunc2:1.0
    //
    virtual TestTruncBase* get_trunc2()
        throw(CORBA::SystemException);

    //
    // IDL:TestOBV/deactivate:1.0
    //
    virtual void deactivate()
        throw(CORBA::SystemException);
};

#endif
