# **********************************************************************
#
# Copyright (c) 1998
# Object-Oriented Concepts, Inc.
# Billerica, MA, USA
#
# Copyright (c) 1998
# Object-Oriented Concepts GmbH
# Ettlingen, Germany
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

IDLDIR		= $(top_srcdir)/idl/OB
INC_IDLDIR	= $(top_srcdir)/idl

TARGETS		= TestActivate.exe \
		  TestAdapterActivator.exe \
		  TestCollocated.exe \
		  TestCreate.exe \
		  TestDestroy.exe \
		  TestFind.exe \
		  TestMisc.exe \
		  TestRefCount.exe \
		  TestClient.exe \
		  TestServantActivatorServer.exe \
		  TestServantLocatorServer.exe \
		  TestDefaultServantServer.exe \
		  TestRefCountServer.exe \
		  TestLocationForwardClient.exe \
		  TestLocationForwardServer.exe

!include $(top_srcdir)\config\Make.rules.mak

COMMON_OBJS	= Test.obj Test_skel.obj TestUtil.obj

FORWARD_OBJS	= Test_impl.obj \
		  TestLocationForwardActivator.obj \
		  TestLocationForwardActivator_skel.obj \
		  TestLocationForwardActivator_impl.obj \
		  TestLocationForward_impl.obj

ALL_CXXFLAGS	= $(CXXFLAGS)
ALL_CPPFLAGS	= /I. /I..\common $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_LIBS	= $(top_srcdir)\lib\obtestcommon.lib $(OB_LIBS) $(LIBS)

TestActivate.exe: $(COMMON_OBJS) TestActivate.obj Test_impl.obj
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(COMMON_OBJS) \
	Test_impl.obj $(ALL_LIBS)

TestCollocated.exe: $(COMMON_OBJS) TestCollocated.obj Test_impl.obj \
                    TestDSI_impl.obj TestRef_impl.obj
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(COMMON_OBJS) \
	Test_impl.obj TestDSI_impl.obj TestRef_impl.obj $(ALL_LIBS)

TestCreate.exe: $(COMMON_OBJS) TestCreate.obj TestUtil.obj
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) TestUtil.obj $(ALL_LIBS)

TestFind.exe: TestFind.obj TestUtil.obj
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) TestUtil.obj $(ALL_LIBS)

TestAdapterActivator.exe: TestAdapterActivator.obj TestUtil.obj
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) TestUtil.obj $(ALL_LIBS)

TestDestroy.exe: TestDestroy.obj TestUtil.obj
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) TestUtil.obj $(ALL_LIBS)

TestMisc.exe: $(COMMON_OBJS) TestMisc.obj Test_impl.obj
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(COMMON_OBJS) \
	Test_impl.obj $(ALL_LIBS)

TestRefCount.exe: $(COMMON_OBJS) TestRefCount.obj TestRef_impl.obj
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(COMMON_OBJS) \
	TestRef_impl.obj $(ALL_LIBS)

TestClient.exe: $(COMMON_OBJS) TestClient.obj
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(COMMON_OBJS) $(ALL_LIBS)

TestServantActivatorServer.exe: $(COMMON_OBJS) TestServantActivatorServer.obj \
                                Test_impl.obj TestDSI_impl.obj \
                                TestServer_impl.obj
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(COMMON_OBJS) \
	Test_impl.obj TestDSI_impl.obj TestServer_impl.obj $(ALL_LIBS)

TestServantLocatorServer.exe: $(COMMON_OBJS) TestServantLocatorServer.obj \
                              Test_impl.obj TestDSI_impl.obj \
                              TestServer_impl.obj
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(COMMON_OBJS) \
	Test_impl.obj TestDSI_impl.obj TestServer_impl.obj $(ALL_LIBS)

TestDefaultServantServer.exe: $(COMMON_OBJS) TestDefaultServantServer.obj \
                              Test_impl.obj TestDSI_impl.obj \
                              TestServer_impl.obj
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(COMMON_OBJS) \
	Test_impl.obj TestDSI_impl.obj TestServer_impl.obj $(ALL_LIBS)

TestRefCountServer.exe: $(COMMON_OBJS) TestRefCountServer.obj \
                        TestRef_impl.obj TestServer_impl.obj
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(COMMON_OBJS) \
	TestRef_impl.obj TestServer_impl.obj $(ALL_LIBS)

TestLocationForwardClient.exe: $(COMMON_OBJS) $(FORWARD_OBJS) \
                               TestLocationForwardClient.obj
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(COMMON_OBJS) \
	$(FORWARD_OBJS) $(ALL_LIBS)

TestLocationForwardServer.exe: $(COMMON_OBJS) $(FORWARD_OBJS) \
                               TestLocationForwardServer.obj
	$(LINK) $(LINKFLAGS) /out:$@ $(@:.exe=.obj) $(COMMON_OBJS) \
	$(FORWARD_OBJS) $(ALL_LIBS)

Test.cpp Test.h: Test.idl
	del /q Test.cpp Test.h
	del /q Test_skel.cpp Test_skel.h
	$(IDL) --no-type-codes Test.idl

Test_skel.cpp Test_skel.h : Test.cpp

TestLocationForwardActivator.cpp TestLocationForwardActivator.h: \
	TestLocationForwardActivator.idl
	del /q TestLocationForwardActivator.cpp TestLocationForwardActivator.h
	del /q TestLocationForwardActivator_skel.cpp
	del /q TestLocationForwardActivator.h
	$(IDL) -I$(INC_IDLDIR) -I. --no-type-codes TestLocationForwardActivator.idl

TestLocationForwardActivator_skel.cpp TestLocationForwardActivator_skel.h : \
	TestLocationForwardActivator.cpp

!include .windep
