// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <TestLocationForwardActivator_skel.h>
#include <Test_impl.h>
#include <TestLocationForward_impl.h>

using namespace CORBA;
using namespace PortableServer;

TestLocationForward_impl::TestLocationForward_impl(ORB_ptr orb)
    : Test_impl(orb)
{
}

void
TestLocationForward_impl::deactivate_servant()
    throw(SystemException)
{
    
    Object_var currentObj;
    
    try
    {
        currentObj = orb_ -> resolve_initial_references("POACurrent");
    }
    catch(const UserException&)
    {
    }
    
    PortableServer::Current_var current;
    if(!is_nil(currentObj))
        current = PortableServer::Current::_narrow(currentObj);
    assert(!is_nil(current));
    
    ObjectId_var oid = current -> get_object_id();
    POA_var poa = current -> get_POA();
    
    poa -> deactivate_object(oid);
}
