// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <Test_skel.h>
#include <TestRef_impl.h>

#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

using namespace CORBA;
using namespace PortableServer;

TestRef_impl::TestRef_impl(ORB_ptr orb, const char* name, Boolean compare)
    : orb_(ORB::_duplicate(orb)), name_(string_dup(name)),
      compare_(compare)
{
}

TestRef_impl::~TestRef_impl()
{
    //cout << "** TestRef_impl `" << name_ << "' destroyed" << endl;
}

void
TestRef_impl::_add_ref()
{
    RefCountServantBase::_add_ref();
    //cout << "** ref count of `" << name_ << "' is now " << _OB_getRef()
    //     << endl;
}

void
TestRef_impl::_remove_ref()
{
    //cout << "** ref count of `" << name_ << "' is now " << (_OB_getRef() - 1)
    //     << endl;
    RefCountServantBase::_remove_ref();
}

void
TestRef_impl::aMethod()
    throw(SystemException)
{
    Object_var currentObj;

    try
    {
        currentObj = orb_ -> resolve_initial_references("POACurrent");
    }
    catch(const UserException&)
    {
    }

    PortableServer::Current_var current;
    if(!is_nil(currentObj))
        current = PortableServer::Current::_narrow(currentObj);
    assert(!is_nil(current));

    ObjectId_var oid = current -> get_object_id();
    String_var oidString = ObjectId_to_string(oid);

    if(compare_)
        assert(strcmp(oidString, name_) == 0);

    //cout << name_ << '(' << oidString << "): aMethod" << endl;
}
