// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <assert.h>
#include <stdlib.h>

#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

using namespace CORBA;
using namespace PortableServer;

POA_ptr
TestUtil_GetRootPOA(ORB_ptr orb)
{
    Object_var obj;

    try
    {
        obj = orb -> resolve_initial_references("RootPOA");
    }
    catch(const ORB::InvalidName&)
    {
	cerr << "Error: can't resolve `RootPOA'" << endl;
	exit(1);
    }

    if(is_nil(obj))
    {
	cerr << "Error: `RootPOA' is a nil object reference" << endl;
	exit(1);
    }

    POA_var root = POA::_narrow(obj);

    if(is_nil(root))
    {
	cerr << "Error: `RootPOA' is not a POA object reference" << endl;
	exit(1);
    }

    return root._retn();
}

bool TestUtil_Compare(const ObjectId& id1, const ObjectId& id2)
{
    return (id1.length() == id2.length() &&
            memcmp(id1.get_buffer(), id2.get_buffer(), id1.length()) == 0);
}
