// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <Test_skel.h>
#include <Test_impl.h>

#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

using namespace CORBA;
using namespace PortableServer;

Test_impl::Test_impl(ORB_ptr orb, const char* name, Boolean compare)
    : orb_(ORB::_duplicate(orb)), name_(string_dup(name)), compare_(compare)
{
}

void
Test_impl::aMethod()
    throw(SystemException)
{
    Object_var currentObj;

    try
    {
        currentObj = orb_ -> resolve_initial_references("POACurrent");
    }
    catch(const UserException&)
    {
    }

    PortableServer::Current_var current;
    if(!is_nil(currentObj))
        current = PortableServer::Current::_narrow(currentObj);
    assert(!is_nil(current));

    ObjectId_var oid = current -> get_object_id();
    String_var oidString = ObjectId_to_string(oid);

    if(compare_)
        assert(strcmp(oidString, name_) == 0);
    
    //cout << name_ << ": aMethod" << endl;
}
