// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <stdio.h>

#include <OB/CORBA.h>
#include <TestMacro.h>

#include <Constants.h>

//#include <string.h>

using namespace CORBA;

void
TestConst()
{
    {
	const Long constLong = -1234;
	TEST(constLong == ConstLong);
	
	const ULong constULong = (5432 + constLong ) * 100 % 124;
	TEST(constULong == ConstULong);
	
	const Double constDouble = 50.23 - constLong *
	    (constULong - 3.14);
	TEST(constDouble == ConstDouble);
	
	const Float constFloat = (Float)(constDouble * 1.11);
//
// Visual C++ fails on this test. If I put a print statement for constFloat
// and ConstFloat, the test succeeds. So I assume this is a Visual C++ bug.
//
#ifndef HAVE_VCPLUSPLUS_BUGS
	TEST(constFloat == ConstFloat);
#endif
	
	const Short constShort = -23 % 10;
	TEST(constShort == ConstShort);
	
	const Boolean constBoolean = true;
	TEST(constBoolean == ConstBoolean);
	
	const char* constString = "This is ConstString";
	TEST(strcmp(constString, ConstString) == 0);
    }

    {
	const Long constLong = (0xf | 0xf000) & 0xfffe;
	TEST(constLong == TestConstInterface::ConstLong);
	
	const Char constChar1 = (Char)'c';
	TEST(constChar1 == TestConstInterface::ConstChar1);
	
	const Char constChar2 = (Char)'\n';
	TEST(constChar2 == TestConstInterface::ConstChar2);
	
	const Char constChar3 = (Char)'\377';
	TEST(constChar3 == TestConstInterface::ConstChar3);
	
	const Char constChar4 = (Char)'\x88';
	TEST(constChar4 == TestConstInterface::ConstChar4);
	
	const Char constChar5 = (Char)'\'';
	TEST(constChar5 == TestConstInterface::ConstChar5);
	
	const char* constString = "\n\t\v\b\r\f\a\\\?\'\"\xff\377\7";
	TEST(strcmp(constString, TestConstInterface::ConstString) == 0);
    }
}
