// **********************************************************************
//
// Copyright (c) 1999
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1999
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <TestMacro.h>

using namespace CORBA;

void
TestFixed()
{
    //
    // Test type conversions
    //
    {
	LongLong l;

	Fixed fixedLong = (Long)123456L;
	Fixed fixedDouble = 123456.0;
	Fixed fixedString = "123456";

	l = (LongLong)fixedLong;
	TEST(l == 123456L);

	l = (LongLong)fixedDouble;
	TEST(l == 123456L);

	l = (LongLong)fixedString;
	TEST(l == 123456L);
    }

    //
    // Test comparisons
    //
    {
	Fixed val1 = (Long)100L;
	Fixed val2 = (Long)99L;
	Fixed val3 = (Long)101L;
	TEST(val1 == val1);
	TEST(val2 != val3);
	TEST(val1 > val2);
	TEST(val1 >= val2);
	TEST(val2 < val3);
	TEST(val2 <= val3);
    }

    //
    // Test basic integer arithmetics
    //
    {
	Fixed val1;
	Fixed val2;
	Fixed val3;

	val1 = (Long)100L;
	val1++;
	TEST((LongLong)val1 == 101L);

	val1 += (Long)99L;
	TEST((LongLong)val1 == 200L);

	val1--;
	TEST((LongLong)val1 == 199L);

	val1 -= (Long)200L;
	TEST((LongLong)val1 == -1L);

	++val1;
	TEST(!val1);

	val1 = (Long)100L;
	val2 = "2000.0";
	val3 = val1 + val2;
	TEST((LongLong)val3 == 2100L);

	val1 = (Long)1234L;
	val2 = (Long)2468L;
	val3 = val1 * val2;
	TEST((LongLong)val3 == 3045512L);

	val3 *= (Long)-2L;
	TEST((LongLong)val3 == -6091024L);
	val3 *= val1;
	TEST(val3 == Fixed("-7516323616"));
	val3 *= -val2;
	TEST(val3 == Fixed("18550286684288"));
	val3 *= val3;
	TEST(val3 == Fixed("344113136069272680986066944"));
    }
}
